﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Signup.aspx.cs" Inherits="Medweb.Cloud.Web.Site.Signup" %>
<%@ Import Namespace="Medweb.Cloud.Web.Site" %>


<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <meta charset="utf-8" />
    <%--<meta name="viewport" content="width=device-width" />--%>
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0" />
    <meta name="mobile-web-app-capable" content="yes" />
    <link rel="icon" sizes="128x128" href="/images/first_aid.png" />

    <title><%= LocalizationUtils.Localize("medweb.cloud.company.signup.title.header") %></title>
    <script type="text/javascript">
        <asp:Literal ID="js" runat="server"></asp:Literal>
    </script>
    
    <script type="text/javascript" src="/scripts/Scripts.js?target=core&<%=Medweb.Cloud.Web.Site.Utilities.GetJSQueryString() %>"></script>  
    <script type="text/javascript" src="/scripts/bootstrap.min.js?1"></script>
    <script type="text/javascript" src="/scripts/bootbox.min.js?1"></script>
    <script type="text/javascript" src="/scripts/validator.js?1"></script>   
    <script type="text/javascript" src="/scripts/clipboard.min.js?1"></script>     
    <script type="text/javascript" src="/scripts/jquery-purl.js?1"></script> 
    <script type="text/javascript" src="/scripts/app/Shared.js?1"></script>  
    <script type="text/javascript" src="/scripts/app/Signup.js?1"></script>  


    <link href="//netdna.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css" rel="stylesheet" />    
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap-glyphicons.css" rel="stylesheet" />    
    <link href="/styles/nav-wizard.bootstrap.css" rel="stylesheet" />
    <link href="/styles/Signup.css" rel="stylesheet" />    
</head>
<body>
    <div class="container">
        <input id="emailLabelText" type="hidden" value="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.email.label") %>"/>          
        <input id="sendEmailLabelText" type="hidden" value="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.sendemail.label") %>"/>          
        <input id="sendLabelText" type="hidden" value="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.send.label") %>"/>          
        <input id="cancelLabelText" type="hidden" value="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.cancel.label") %>"/>          
        <input id="sentEmailLabelText" type="hidden" value="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.emailsent.label") %>"/>                  

        <div class="panel panel-default">
            <div class="panel-heading clearfix">
                <h3><span class="glyphicon glyphicon-plus"></span> <%= LocalizationUtils.Localize("medweb.cloud.company.signup.title.label") %></h3>
                <h4><%= LocalizationUtils.Localize("medweb.cloud.company.signup.subtitle.label") %></h4>
            </div>
            
            <ul class="nav nav-pills nav-wizard">
                <li class="active"><a><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step1.label") %></a><div class="nav-arrow"></div></li>
                <li><div class="nav-wedge"></div><a><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step2.label") %></a><div class="nav-arrow"></div></li>
                <li><div class="nav-wedge"></div><a><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step3.label") %></a></li>
            </ul>
            
            <div id="alert_template" style="display: none;" class="alert alert-danger">
                <a href="#" class="close" data-hide="alert">&times;</a>
                <strong><%= LocalizationUtils.Localize("medweb.cloud.company.signup.error.label") %></strong> <span id="alert_template_message"></span>
            </div>

            <div id="step1-panel" class="panel-body">           
                <form id="step1-form" data-toggle="validator" role="form" onsubmit="return false;">
                    <div class="section-header"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step1.title.label") %></div>      

                    <div class="form-group has-feedback">
                        <label for="nameField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.name.label") %></label>                        
                        <input id="nameField" type="text" class="form-control" required="required" autofocus="autofocus" placeholder="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.name.placeholder") %>" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.error.required") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>                        
                        <div class="help-block with-errors"></div>
                    </div>

                    <div class="form-group has-feedback">
                        <label for="companyField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.company.label") %></label>                        
                        <input id="companyField" type="text" class="form-control" required="required" placeholder="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.company.placeholder") %>" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.error.required") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>                        
                        <div class="help-block with-errors"></div>
                    </div>

                    <div class="form-group has-feedback">
                        <label for="phoneField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.phone.label") %></label>
                        <input id="phoneField" type="text" class="form-control" required="required" pattern="\+?[0-9]{7,15}" placeholder="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.phone.placeholder") %>" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.phone.help") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>
                        <div class="help-block with-errors"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.phone.help") %></div>
                    </div>

                    <div class="form-group has-feedback">
                        <label for="emailField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.email.label") %></label>
                        <input id="emailField" type="email" class="form-control" required="required" placeholder="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.email.placeholder") %>" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.error.required") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>
                        <div class="help-block with-errors"></div>
                    </div>

                    <div class="form-group has-feedback">
                        <label for="passwordField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.password.label") %></label>
                        <input id="passwordField" type="password" class="form-control" required="required" data-minlength="5" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.password.help") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>
                        <div class="help-block with-errors"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.password.help") %></div>
                    </div>

                    <div class="form-group has-feedback password-confirm-group">
                        <label for="passwordConfirmationField" class="control-label"><%= LocalizationUtils.Localize("medweb.user.password.confirm.label") %></label>
                        <input id="passwordConfirmationField" type="password" class="form-control" required="required" data-error="<%= LocalizationUtils.Localize("medweb.cloud.exception.user.password.donotmatch") %>"/>
                        <span class="glyphicon form-control-feedback" aria-hidden="true"></span>
                        <div class="help-block with-errors"></div>
                    </div>

                    <div class="form-group has-feedback domain-group">                        
                        <label id="domainLabel" for="domainField" class="control-label"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.domain.label") %></label><span id="domain-error"></span>
                        <div id="domainContainer">
                            <input id="domainField" type="text" class="form-control" required="required" pattern="[a-zA-Z0-9]+" placeholder="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.domain.placeholder") %>" data-error="<%= LocalizationUtils.Localize("medweb.cloud.company.signup.domain.help") %>"/>
                            <span class="glyphicon form-control-feedback domain-glyph" aria-hidden="true"></span>
                        </div>
                        <div id="domain-suffix">.medweb.xyz</div>                        
                        <div class="help-block with-errors"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.domain.help") %></div>                                                
                    </div>                                      

                    <div class="form-group">
                        <button id="step1-next" type="submit" class="btn btn-primary next">
                            <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.createaccount.title.label") %></span>
                        </button>
                    </div>        
                </form>
            </div> 
            
            <div id="step2-panel" class="panel-body" style="display:none">                                          
                <div><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step2.title.label") %></div>          
                <input id="evisit-label" type="hidden" value="<%= LocalizationUtils.Localize("medweb.modules.evisit.label") %>"/>          
                <input id="evisit-manage-label" type="hidden" value="<%= LocalizationUtils.Localize("medwebmedweb.modules.evisit.label") %>"/>          
               <div>
                    <pre id="step2-code">                       
                    </pre>
                    <button id="step2-copy" class="btn btn-primary code-btn clipboard-btn" data-clipboard-target="#step2-code">
                        <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.copy.label") %></span>
                    </button>  
                    <button id="step2-email" class="btn btn-primary code-btn">
                        <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.email.label") %></span>
                    </button>  
               </div>       
                <div class="clear"></div>
                <button id="step2-next" class="btn btn-primary next">
                    <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.next.title.label") %></span>
                </button>                                      
            </div>
            
            <div id="step3-panel" class="panel-body" style="display:none">           
                <div><%= LocalizationUtils.Localize("medweb.cloud.company.signup.step3.title.label") %></div>      
                   
               <div>
                    <pre id="step3-code">
                    </pre>
                    <button id="step3-copy" class="btn btn-primary code-btn clipboard-btn" data-clipboard-target="#step3-code">
                        <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.copy.label") %></span>
                    </button>  
                    <button id="step3-email" class="btn btn-primary code-btn">
                        <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.email.label") %></span>
                    </button>  
               </div>   

                <div class="clear"></div>
                <button id="step3-previous" class="btn btn-primary">
                    <span class="btnText"><%= LocalizationUtils.Localize("medweb.cloud.company.signup.previous.title.label") %></span>
                </button>                                                              
            </div>                                   
        </div>
    </div>   
</body>
</html>
