﻿MedwebCloud = window.MedwebCloud || {};
MedwebCloud.openSessions = 0;
Ext.eventBus = new Ext.util.Observable();

// invitations when online on web app
// status updates
// user/company admin
// map from android side (target user will show map of specific user, no user will be map of all buddies)

// TODO: Remove this once TheRest mono bug is fixed
Ext.Ajax.disableCaching = false;

Ext.Msg.toast = function (args) {
    Ext.create('widget.uxNotification', {
        position: 'br',
        cls: 'ux-notification ux-notification-light',
        closable: true,
        title: args.title || 'Notice',
        iconCls: 'ux-notification-icon-information',
        html: args.body,
        stickOnClick: false,
        handler: args.handler || function () {
        }
    }).show();
};

Math.trueRandom = (function () {
    var crypto = window.msCrypto || window.crypto || null;
    if (crypto && crypto.getRandomValues) {
        // if we have a crypto library, use it
        return function () {
            var array = new Uint32Array(1);
            crypto.getRandomValues(array);
            var intVal = array[0];
            return intVal / (Math.pow(10, (intVal + '').length));
        };
    } else {
        // From http://baagoe.com/en/RandomMusings/javascript/
        // Johannes BaagÃ¸e <baagoe@baagoe.com>, 2010
        function Mash() {
            var n = 0xefc8249d;

            var mash = function (data) {
                data = data.toString();
                for (var i = 0; i < data.length; i++) {
                    n += data.charCodeAt(i);
                    var h = 0.02519603282416938 * n;
                    n = h >>> 0;
                    h -= n;
                    h *= n;
                    n = h >>> 0;
                    h -= n;
                    n += h * 0x100000000; // 2^32
                }
                return (n >>> 0) * 2.3283064365386963e-10; // 2^-32
            };

            mash.version = 'Mash 0.9';
            return mash;
        }

        // From http://baagoe.com/en/RandomMusings/javascript/
        function Alea() {
            return (function (args) {
                // Johannes BaagÃ¸e <baagoe@baagoe.com>, 2010
                var s0 = 0;
                var s1 = 0;
                var s2 = 0;
                var c = 1;

                if (args.length == 0) {
                    args = [+new Date()];
                }
                var mash = Mash();
                s0 = mash(' ');
                s1 = mash(' ');
                s2 = mash(' ');

                for (var i = 0; i < args.length; i++) {
                    s0 -= mash(args[i]);
                    if (s0 < 0) {
                        s0 += 1;
                    }
                    s1 -= mash(args[i]);
                    if (s1 < 0) {
                        s1 += 1;
                    }
                    s2 -= mash(args[i]);
                    if (s2 < 0) {
                        s2 += 1;
                    }
                }
                mash = null;

                var random = function () {
                    var t = 2091639 * s0 + c * 2.3283064365386963e-10; // 2^-32
                    s0 = s1;
                    s1 = s2;
                    return s2 = t - (c = t | 0);
                };
                random.uint32 = function () {
                    return random() * 0x100000000; // 2^32
                };
                random.fract53 = function () {
                    return random() +
                        (random() * 0x200000 | 0) * 1.1102230246251565e-16; // 2^-53
                };
                random.version = 'Alea 0.9';
                random.args = args;
                return random;
            }(Array.prototype.slice.call(arguments)));
        };
        return Alea();
    }
}());

Math.guid = function () {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.trueRandom() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
};

MedwebCloud.getLocation = function (success, failure) {
    if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(success, failure);
    } else {
        failure('Geolocation is not supported.');
    }
};

MedwebCloud.getDeviceUniqueId = function () {
    var id = Ext.util.Cookies.get('mwc_device_uniqueid');
    if (!id) {
        id = Math.guid();
        Ext.util.Cookies.set('mwc_device_uniqueid', id, Ext.Date.add((new Date()), Ext.Date.YEAR, 15));
    }
    return id;
};

window.ondrop = window.ondragover = function (e) {
    return false;
};

Ext.application({
    name: 'MedwebCloud',
    appFolder: '/scripts/app',
    requires: ['Ext.ux.i18n.Bundle'],
    bundle: MedwebCloud.bundle,

    launch: function () {
        // Hold a reference to the application.
        MedwebCloud.app = this;

        //Apply the host info to bundle data before using it
        var format = function (str, col) {
            col = typeof col === 'object' ? col : Array.prototype.slice.call(arguments, 1);
            return str.replace(/\{\{|\}\}|\{([\w_]+)\}/g, function substitute(m, n) {
                if (m == "{{") {
                    return "{";
                } if (m == "}}") {
                    return "}";
                }
                return col[n] || '{' + n + '}';
            });
        };
        var hostSubstitution = {}
        Ext.Object.each(MedwebCloud.UIConfig.HostContext || {}, function (key, value, all) {
            this["Host_" + key] = value;
        }, hostSubstitution);
        MedwebCloud.getApplication().bundle.each(function (record, idx, count) {
            var newVal = record.get('value');
            record.set('value', format(newVal, hostSubstitution));
        });
        // i18n loads first
        MedwebCloud.getMsg = function () {
            var bdl = MedwebCloud.getApplication().bundle;
            return bdl.getMsg.apply(bdl, arguments);
        };

        MedwebCloud.formatDate = function (value) {
            var format = MedwebCloud.getMsg('medweb.datetime.format');
            return Ext.Date.format(value, format);
        };

        MedwebCloud.Core = MedwebCloud.Core || {};
        MedwebCloud.Core.Enums = MedwebCloud.Core.Enums || {};
        MedwebCloud.Core.Enums.Presence = {
            Offline: 1,
            Busy: 2,
            Active: 3,
            Idle: 4
        };

        MedwebCloud.getPresenceClassName = function (v) {
            var cls = '';
            if (v == MedwebCloud.Core.Enums.Presence.Idle) {
                cls = 'idle';
            } else if (v == MedwebCloud.Core.Enums.Presence.Busy) {
                cls = 'busy';
            } else if (v == MedwebCloud.Core.Enums.Presence.Active) {
                cls = 'active';
            } else {
                cls = 'offline';
            }
            return cls;
        };

        MedwebCloud.MD5 = function (s) { function L(k, d) { return (k << d) | (k >>> (32 - d)) } function K(G, k) { var I, d, F, H, x; F = (G & 2147483648); H = (k & 2147483648); I = (G & 1073741824); d = (k & 1073741824); x = (G & 1073741823) + (k & 1073741823); if (I & d) { return (x ^ 2147483648 ^ F ^ H) } if (I | d) { if (x & 1073741824) { return (x ^ 3221225472 ^ F ^ H) } else { return (x ^ 1073741824 ^ F ^ H) } } else { return (x ^ F ^ H) } } function r(d, F, k) { return (d & F) | ((~d) & k) } function q(d, F, k) { return (d & k) | (F & (~k)) } function p(d, F, k) { return (d ^ F ^ k) } function n(d, F, k) { return (F ^ (d | (~k))) } function u(G, F, aa, Z, k, H, I) { G = K(G, K(K(r(F, aa, Z), k), I)); return K(L(G, H), F) } function f(G, F, aa, Z, k, H, I) { G = K(G, K(K(q(F, aa, Z), k), I)); return K(L(G, H), F) } function D(G, F, aa, Z, k, H, I) { G = K(G, K(K(p(F, aa, Z), k), I)); return K(L(G, H), F) } function t(G, F, aa, Z, k, H, I) { G = K(G, K(K(n(F, aa, Z), k), I)); return K(L(G, H), F) } function e(G) { var Z; var F = G.length; var x = F + 8; var k = (x - (x % 64)) / 64; var I = (k + 1) * 16; var aa = Array(I - 1); var d = 0; var H = 0; while (H < F) { Z = (H - (H % 4)) / 4; d = (H % 4) * 8; aa[Z] = (aa[Z] | (G.charCodeAt(H) << d)); H++ } Z = (H - (H % 4)) / 4; d = (H % 4) * 8; aa[Z] = aa[Z] | (128 << d); aa[I - 2] = F << 3; aa[I - 1] = F >>> 29; return aa } function B(x) { var k = "", F = "", G, d; for (d = 0; d <= 3; d++) { G = (x >>> (d * 8)) & 255; F = "0" + G.toString(16); k = k + F.substr(F.length - 2, 2) } return k } function J(k) { k = k.replace(/rn/g, "n"); var d = ""; for (var F = 0; F < k.length; F++) { var x = k.charCodeAt(F); if (x < 128) { d += String.fromCharCode(x) } else { if ((x > 127) && (x < 2048)) { d += String.fromCharCode((x >> 6) | 192); d += String.fromCharCode((x & 63) | 128) } else { d += String.fromCharCode((x >> 12) | 224); d += String.fromCharCode(((x >> 6) & 63) | 128); d += String.fromCharCode((x & 63) | 128) } } } return d } var C = Array(); var P, h, E, v, g, Y, X, W, V; var S = 7, Q = 12, N = 17, M = 22; var A = 5, z = 9, y = 14, w = 20; var o = 4, m = 11, l = 16, j = 23; var U = 6, T = 10, R = 15, O = 21; s = J(s); C = e(s); Y = 1732584193; X = 4023233417; W = 2562383102; V = 271733878; for (P = 0; P < C.length; P += 16) { h = Y; E = X; v = W; g = V; Y = u(Y, X, W, V, C[P + 0], S, 3614090360); V = u(V, Y, X, W, C[P + 1], Q, 3905402710); W = u(W, V, Y, X, C[P + 2], N, 606105819); X = u(X, W, V, Y, C[P + 3], M, 3250441966); Y = u(Y, X, W, V, C[P + 4], S, 4118548399); V = u(V, Y, X, W, C[P + 5], Q, 1200080426); W = u(W, V, Y, X, C[P + 6], N, 2821735955); X = u(X, W, V, Y, C[P + 7], M, 4249261313); Y = u(Y, X, W, V, C[P + 8], S, 1770035416); V = u(V, Y, X, W, C[P + 9], Q, 2336552879); W = u(W, V, Y, X, C[P + 10], N, 4294925233); X = u(X, W, V, Y, C[P + 11], M, 2304563134); Y = u(Y, X, W, V, C[P + 12], S, 1804603682); V = u(V, Y, X, W, C[P + 13], Q, 4254626195); W = u(W, V, Y, X, C[P + 14], N, 2792965006); X = u(X, W, V, Y, C[P + 15], M, 1236535329); Y = f(Y, X, W, V, C[P + 1], A, 4129170786); V = f(V, Y, X, W, C[P + 6], z, 3225465664); W = f(W, V, Y, X, C[P + 11], y, 643717713); X = f(X, W, V, Y, C[P + 0], w, 3921069994); Y = f(Y, X, W, V, C[P + 5], A, 3593408605); V = f(V, Y, X, W, C[P + 10], z, 38016083); W = f(W, V, Y, X, C[P + 15], y, 3634488961); X = f(X, W, V, Y, C[P + 4], w, 3889429448); Y = f(Y, X, W, V, C[P + 9], A, 568446438); V = f(V, Y, X, W, C[P + 14], z, 3275163606); W = f(W, V, Y, X, C[P + 3], y, 4107603335); X = f(X, W, V, Y, C[P + 8], w, 1163531501); Y = f(Y, X, W, V, C[P + 13], A, 2850285829); V = f(V, Y, X, W, C[P + 2], z, 4243563512); W = f(W, V, Y, X, C[P + 7], y, 1735328473); X = f(X, W, V, Y, C[P + 12], w, 2368359562); Y = D(Y, X, W, V, C[P + 5], o, 4294588738); V = D(V, Y, X, W, C[P + 8], m, 2272392833); W = D(W, V, Y, X, C[P + 11], l, 1839030562); X = D(X, W, V, Y, C[P + 14], j, 4259657740); Y = D(Y, X, W, V, C[P + 1], o, 2763975236); V = D(V, Y, X, W, C[P + 4], m, 1272893353); W = D(W, V, Y, X, C[P + 7], l, 4139469664); X = D(X, W, V, Y, C[P + 10], j, 3200236656); Y = D(Y, X, W, V, C[P + 13], o, 681279174); V = D(V, Y, X, W, C[P + 0], m, 3936430074); W = D(W, V, Y, X, C[P + 3], l, 3572445317); X = D(X, W, V, Y, C[P + 6], j, 76029189); Y = D(Y, X, W, V, C[P + 9], o, 3654602809); V = D(V, Y, X, W, C[P + 12], m, 3873151461); W = D(W, V, Y, X, C[P + 15], l, 530742520); X = D(X, W, V, Y, C[P + 2], j, 3299628645); Y = t(Y, X, W, V, C[P + 0], U, 4096336452); V = t(V, Y, X, W, C[P + 7], T, 1126891415); W = t(W, V, Y, X, C[P + 14], R, 2878612391); X = t(X, W, V, Y, C[P + 5], O, 4237533241); Y = t(Y, X, W, V, C[P + 12], U, 1700485571); V = t(V, Y, X, W, C[P + 3], T, 2399980690); W = t(W, V, Y, X, C[P + 10], R, 4293915773); X = t(X, W, V, Y, C[P + 1], O, 2240044497); Y = t(Y, X, W, V, C[P + 8], U, 1873313359); V = t(V, Y, X, W, C[P + 15], T, 4264355552); W = t(W, V, Y, X, C[P + 6], R, 2734768916); X = t(X, W, V, Y, C[P + 13], O, 1309151649); Y = t(Y, X, W, V, C[P + 4], U, 4149444226); V = t(V, Y, X, W, C[P + 11], T, 3174756917); W = t(W, V, Y, X, C[P + 2], R, 718787259); X = t(X, W, V, Y, C[P + 9], O, 3951481745); Y = K(Y, h); X = K(X, E); W = K(W, v); V = K(V, g) } var i = B(Y) + B(X) + B(W) + B(V); return i.toLowerCase() };

        MedwebCloud.getGravatarUrl = function (email, size) {
            var hash = MedwebCloud.MD5(email);
            return '//www.gravatar.com/avatar/' + hash + '?d=mm&size=' + (size || '');
        };

        // load up everything else
        var url = '/scripts/Scripts.js?target=default';
        if (window.isDebug || !!window.localStorage.getItem('mw.debug') || (MedwebCloud.UIConfig && MedwebCloud.UIConfig.Debug)) { //window.isDebug is set in Shared.js
            url += '&debug=true';
        }
        if (MedwebCloud.UIConfig && MedwebCloud.UIConfig.Version) {
            url += '&v=' + MedwebCloud.UIConfig.Version;
        }

        Ext.Loader.injectScriptElement(url, function () {
            if (window.isDebug || !!window.localStorage.getItem('mw.debug')) { //window.isDebug is set in Shared.js
                fm.log.setProvider(new fm.consoleLogProvider(), fm.logLevel.Debug);
            }

            function contactWindow(winTitle, okTitle, cancelTitle, labelDisplayName, labelEmail, currentDisplayName, currentEmail, callback) {
                var w = new Ext.Window({
                    modal: true,
                    title: winTitle,
                    layout: 'fit',
                    height: 150,
                    width: 400,
                    items: [{
                        border: false,
                        xtype: 'form',
                        defaults: {
                            anchor: '100%',
                            padding: '0 15 5 15'
                        },
                        items: [{
                            xtype: 'textfield',
                            fieldLabel: labelDisplayName,
                            name: 'DisplayName',
                            value: currentDisplayName,
                            allowBlank: false,
                            minLength: 2,
                            padding: '15 15 5 15'
                        }, {
                            xtype: 'textfield',
                            fieldLabel: labelEmail,
                            allowBlank: false,
                            vtype: 'email',
                            value: currentEmail,
                            minLength: 5,
                            name: 'Email'
                        }]
                    }],
                    buttons: [{
                        text: okTitle,
                        handler: function () {
                            var form = w.down('.form');
                            if (form.isValid()) {
                                var values = form.getValues();
                                callback(values);
                                w.close();
                            }
                        }
                    }, {
                        text: cancelTitle,
                        handler: function () {
                            w.close();
                        }
                    }]
                });
                w.show();
            }

            MedwebCloud.createContact = function (callback) {
                var winTitle = MedwebCloud.getMsg('medweb.contact.create_and_invite.window.title');
                var okTitle = MedwebCloud.getMsg('medweb.contact.create_and_invite.button.positive.label');
                var cancelTitle = MedwebCloud.getMsg('medweb.common.button.negative.label');
                var labelDisplayName = MedwebCloud.getMsg('medweb.user.displayname.label');
                var labelEmail = MedwebCloud.getMsg('medweb.user.email.label');

                contactWindow(winTitle, okTitle, cancelTitle, labelDisplayName, labelEmail, '', '', callback);
            };

            MedwebCloud.updateContact = function (currentDisplayName, currentEmail, callback) {
                var winTitle = MedwebCloud.getMsg('medweb.contact.create_and_invite.window.title');
                var okTitle = MedwebCloud.getMsg('medweb.contact.create_and_invite.button.positive.label');
                var cancelTitle = MedwebCloud.getMsg('medweb.common.button.negative.label');
                var labelDisplayName = MedwebCloud.getMsg('medweb.user.displayname.label');
                var labelEmail = MedwebCloud.getMsg('medweb.user.email.label');

                contactWindow(winTitle, okTitle, cancelTitle, labelDisplayName, labelEmail, currentDisplayName, currentEmail, callback);
            };

            Ext.state.Manager.setProvider(Ext.create('Ext.state.CookieProvider'));

            // soundManager has an annoying habit of failing to load; some sort of timing issue when loading it through script injection
            // this will keep trying until it's up
            var smt = window.setInterval(function () {
                try {
                    soundManager.setup({
                        preferFlash: false,
                        url: '/scripts/soundmanager/swf/',
                        onready: function () {
                            window.clearInterval(smt);
                            console.log('ready');
                        }
                    });
                } catch (e) { }
            }, 500);

            // set up communications and logging
            MedwebCloud.websyncClient = new fm.websync.client(MedwebCloud.websyncPath);

            fm.icelink.webrtc.setActiveX({
                path_x86: '/scripts/fm/Medweb.WebRTC.x86.cab',
                path_x64: '/scripts/fm/Medweb.WebRTC.x64.cab'
            });

            //fm.log.setProvider(new fm.consoleLogProvider(fm.logLevel.Info));

            // Update the error text for AdvancedVTypes.js to i18nized.
            Ext.apply(Ext.form.field.VTypes, {
                daterangeText: MedwebCloud.getMsg('medweb.vtype.daterange.error.message'),
                passwordText: MedwebCloud.getMsg('medweb.vtype.passwords.error.message')
            });

            // Apply a set of config properties to the singleton QuickTip
            Ext.apply(Ext.tip.QuickTipManager.getQuickTip(), {
                dismissDelay: 20000
            });

            // load the user models
            MedwebCloud.loadModels(function () {
                // load the user's profile
                MedwebCloud.app.loadUserProfile(function (userProfile) {
                    var parts = window.location.hostname.split('.');
                    var subdomain = parts[0];
                    var companySubdomain = MedwebCloud.userProfile.Company.Subdomain;
                    if (window.location.hostname != 'localhost' && companySubdomain && subdomain.toLowerCase() != companySubdomain.toLowerCase()) {
                        parts = parts.slice(1);
                        parts.unshift(MedwebCloud.userProfile.Company.Subdomain);
                        host = parts.join('.');

                        // rewrite the host
                        var a = document.createElement('a');
                        a.href = window.location.href;
                        a.hostname = host;
                        window.location.href = a.href;
                        return;
                    }

                    // these match the item ids in a collage session so we can control it from the database
                    // should probably move to an enum or database entry or somthing eventually...probably will need to enable/disable by customer...
                    MedwebCloud.UIConfig.CollageSections = [
                        { Name: 'devices', DisplayName: MedwebCloud.getMsg('medweb.view.sessionpanel.button.devices.label') },
                        { Name: 'images', DisplayName: MedwebCloud.getMsg('medweb.view.sessionpanel.button.images.label') },
                        { Name: 'remoteCameras', DisplayName: MedwebCloud.getMsg('medweb.view.sessionpanel.button.remotecameras.label') },
                        { Name: 'screenShare', DisplayName: MedwebCloud.getMsg('medweb.view.sessionpanel.button.screenshare.label') }
                    ];

                    // create the viewport itself
                    var viewport = MedwebCloud.app.Viewport = Ext.create('MedwebCloud.Viewport', {
                        defaultSection: userProfile.Company.DefaultSection,
                        defaultCollageSection: userProfile.Company.DefaultCollageSection
                    });

                    // flag so we can hide loading screens, etc
                    MedwebCloud.ready = true;

                    MedwebCloud.app.setupWebsync(userProfile);
                });
            });
        });
    },

    setupWebsync: function (userProfile) {
        // connect to WebSync
        var client = MedwebCloud.websyncClient;
        client.setAutoDisconnect({ synchronous: true });

        var dataRecord = {
            os: 'browser',
            client: 'javascript',
            instance: client.getInstanceId(),
            sends: [
                'webrtc/chat',
                'webrtc/video'
            ],
            receives: [
                'webrtc/*',
                'json/*',
                'image/*'
            ],
            extra: {}
        };

        // binds happen before connect to ensure they *always* happen first
        client.bind({
            records: [{
                key: 'medweb.capability',
                value: dataRecord
            }, {
                key: 'username',
                value: userProfile.Username || ""
            }, {
                key: 'displayName',
                value: userProfile.DisplayName || ""
            }],
            onSuccess: function (e) {
                // nada, good to go
            },
            onFailure: function (e) {
                //Ext.Msg.alert('Error', 'Bind failed.');
            }
        });

        // user notifications
        var userChannel = '/' + userProfile.CompanyId + '/user/' + userProfile.Id;
        client.subscribe({
            channel: userChannel,
            onSuccess: function (e) {
            },
            onFailure: function (e) {
            },
            onReceive: function (e) {
                Ext.eventBus.fireEvent(e.getData().NotificationType, e);
            }
        });

        // user presence
        var handlePresence = function (presence) {
            if (presence) {
                for (var i = presence.length - 1; i >= 0; i -= 1) {
                    var userPresence = presence[i];
                    var userId = userPresence.UserId;
                    var presValue = userPresence.Presence;

                    /*
                        Offline: 1,
                        Busy: 2,
                        Active: 3,
                        Idle: 4
                    */
                    switch (presValue) {
                        case 2:
                            Ext.eventBus.fireEvent('user:busy', userId);
                            break;
                        case 3:
                            console.log('pres')
                            Ext.eventBus.fireEvent('user:join', userId);
                            break;
                        case 4:
                            Ext.eventBus.fireEvent('user:leave', userId);
                            break;
                        default:
                            Ext.eventBus.fireEvent('user:offline', userId);
                            break;
                    }
                }
            }
        }

        var presenceChannel = '/' + userProfile.CompanyId + '/presence';
        client.join({
            channel: presenceChannel,
            userId: userProfile.Id.toString(),
            userNickname: userProfile.DisplayName,
            onSuccess: function (e) {
                var presence = e.getExtensionValue('presence');
                handlePresence(presence);

                //var users = e.getUsers();
                //for (var i = 0; i < users.length; i++) {
                //    var user = users[i];
                //    Ext.eventBus.fireEvent('user:join', user);
                //}
            },
            onFailure: function (e) {
                // TODO: on failure, we should really fire events for all the users saying they've left...
            },
            onReceive: function (e) {
                var json = e.getDataJson();
                presence = JSON.parse(json);
                handlePresence(presence);
            }
        });

        var itemsToMask = ['#sessionPanel']; //)[0]];

        client.connect({
            onSuccess: function (e) {
                for (var i = 0; i < itemsToMask.length; i++) {
                    var item = Ext.ComponentQuery.query(itemsToMask[i])[0];
                    if (item) {
                        item.unmask();
                    }
                }
            },
            onFailure: function (e) {
                //Ext.Msg.alert('Error', 'Connection lost.');
            },
            onStreamFailure: function () {
                for (var i = 0; i < itemsToMask.length; i++) {
                    var item = Ext.ComponentQuery.query(itemsToMask[i])[0];
                    if (item) {
                        var msg = MedwebCloud.getMsg('medweb.common.websync.streamfailure.message');
                        item.mask(msg);
                    }
                }
            }
        });
    },

    loadUserProfile: function (callback) {
        var me = this;
        var client = new fm.therest.client(MedwebCloud.apiPath);

        client.send({
            method: fm.httpMethod.Get,
            path: '/v1/authenticate',
            headers: {
                'X-Medweb-Company': window.location.host.split('.')[0],
            },
            onSuccess: function (e) {
                if (e.getResponseData() == null) {
                    window.location.href = './Login.aspx';
                    return;
                }
                MedwebCloud.userProfile = e.getResponseData();
                MedwebCloud.userProfile.isDoctor = function () {
                    return MedwebCloud.userProfile.IsDoctor;
                };
                me.startSessionTimer();

                callback(MedwebCloud.userProfile);

                me.registerAndTrack(MedwebCloud.userProfile);

                // trigger install of the activex control
                fm.icelink.webrtc.userMedia.getMedia({});
            },
            onFailure: function (e) {
                //Ext.Msg.alert("Error", "An error occurred while loading the current user's profile.");
                if (window.location.href.indexOf('GlassSetup') === -1) {
                    window.location.href = "/Login.aspx";
                }
            }
        });
    },

    registerAndTrack: function (profile) {
        var me = this;

        var device = new MedwebCloud.model.Device({
            NotificationToken: 'none',
            NotificationNetwork: 'web',
            UserId: profile.Id,
            UniqueId: MedwebCloud.getDeviceUniqueId()
        });
        device.save({
            success: function (r) {
                // register the current device and start tracking it
                me.locationTrackingInterval = window.setInterval(function () {
                    me.trackLocation(device.get('Id'));
                }, 1000 * 30); // 30 seconds for now
                me.trackLocation(device.get('Id'));
            }
        });
    },

    trackLocation: function (deviceId) {
        var currentLocation = null;
        MedwebCloud.getLocation(function (position) {
            currentLocation = {
                UserId: MedwebCloud.userProfile.Id,
                DeviceId: deviceId,
                Latitude: position.coords.latitude,
                Longitude: position.coords.longitude
            };
        }, function () {
            // error
        });

        MedwebCloud.websyncClient.addOnRequestCreated(function (args) {
            if (currentLocation && MedwebCloud.userProfile.TrackLocation) {
                var requests = args.getRequests();
                for (var i = 0; i < requests.length; i++) {
                    requests[i].setExtensionValue('mwc.location', currentLocation);
                }
            }
        });
    },

    sessionTimeoutMinutes: 20,
    sessionTimer: null,
    sessionMonitor: null,
    dlgSessionTimeOut: null,
    sessionSecondsRemaining: 0,

    startSessionTimer: function () {
        return;
        var me = this;

        // Setup the IdleSessionMonitor to watch for app activity
        me.sessionMonitor = Ext.create('Ext.ux.IdleSessionMonitor', {
            timeout: 60 * 1000  // 60 seconds of no mouse movement of keyboard is considered 'idle' IMO.
        });

        // Setup the cookie timeout timer.
        this.sessionTimer = setTimeout(Ext.bind(me.sessionKeepAlive, this), (me.sessionTimeoutMinutes - 1) * 60 * 1000);

        this.sessionMonitor.start();
    },

    sessionKeepAlive: function () {
        return;

        var me = this;

        if (me.sessionMonitor.isIdle()) {
            // Hmm it looks like the user is idle and our session
            // cookie is about to expire. Give them a warning.
            me.sessionWarnTimeout();
        } else {
            // The user is working away (not-idle) so do a quick update
            // in the background to renew the session cookie expiration
            Ext.Ajax.request({
                method: 'GET',
                url: MedwebCloud.api('/authentication'),
                success: function (response) {
                    // Our session cookie has been extended.
                    // Restart out session cookie timer.
                    if (me.sessionTimer) {
                        clearTimeout(me.sessionTimer);
                        me.sessionTimer = null;
                    }
                    me.sessionTimer = setTimeout(Ext.bind(me.sessionKeepAlive, me), (me.sessionTimeoutMinutes - 1) * 60 * 1000);
                    me.sessionMonitor.restart();
                },
                failure: function (response) {
                    var error = Ext.decode(response.responseText).error;
                    var errorTitle = MedwebCloud.getMsg('medweb.common.error.label');
                    Ext.Msg.alert(errorTitle, error);
                }
            });
        }
    },
    sessionWarnTimeout: function () {
        var me = this;
        var dialogTitle = MedwebCloud.getMsg('medweb.sessiontimeout.dialog.title');
        var dialogMessage = MedwebCloud.getMsg('medweb.sessiontimeout.dialog.message');
        var dialogProgress = MedwebCloud.getMsg('medweb.sessiontimeout.dialog.progressText');
        me.sessionSecondsRemaining = 30;
        me.dlgSessionTimeOut = Ext.MessageBox.show({
            title: dialogTitle,
            msg: dialogMessage,
            progressText: dialogProgress,
            buttons: Ext.MessageBox.OK,
            //buttons: { ok: '<b>Submit</b>', cancel: 'Cancel' },
            icon: Ext.MessageBox.QUESTION,
            width: 300,
            progress: true,
            draggable: false,
            closable: false
        });

        var f = function (v) {
            return function () {
                if (me.sessionSecondsRemaining > 0) {
                    if (Ext.MessageBox.isVisible()) {
                        // Keep the count down going
                        var countdown = MedwebCloud.getMsg('medweb.sessiontimeout.dialog.progressCountdown', me.sessionSecondsRemaining);
                        Ext.MessageBox.updateProgress(((30 - me.sessionSecondsRemaining) / 30), countdown);
                        setTimeout(f(--me.sessionSecondsRemaining), 1000);
                    } else {
                        // They pressed ok, renew the session cookie!
                        //
                        // Safari will allow you to click the dialog's ok button while the browser
                        // window does not have focus, meaning the IdleSessionMonitor still thinks
                        // the user is idle as it didn't see any keyboard or mouse input prior to
                        // the ok button being clicked! So force the idle session monitor to reset
                        // when the dialog receives any input.
                        me.sessionMonitor.restart();
                        me.sessionKeepAlive();
                    }
                } else {
                    // They weren't paying attention, log them out!
                    me.logout(true);
                }
            };
        };
        setTimeout(f(--me.sessionSecondsRemaining), 1000);
    },

    logout: function (timedOut) {
        var dialogTitle = MedwebCloud.getMsg('medweb.logout.dialog.title');
        var dialogMessage = MedwebCloud.getMsg('medweb.logout.dialog.message');
        Ext.Msg.wait(dialogMessage, dialogTitle);
        var da = new fm.websync.disconnectArgs();
        da.setOnComplete(function () {
            Ext.Ajax.request({
                //url: MedwebCloud.api('/authentication'),
                //method: 'DELETE',
                url: MedwebCloud.api('/v1/logout'),
                method: 'POST',
                headers: { 'Content-Type': 'application/json' },
                jsonData: {},
                success: function (response) {
                    // logged out
                    if (timedOut) {
                        window.location.href = '/Login.aspx?sessiontimeout=1';
                    } else {
                        window.location.href = '/Login.aspx';
                    }
                },
                failure: function (response) {
                    window.location.href = '/Login.aspx?sessiontimeout=1';
                }
            });
        });
        MedwebCloud.websyncClient.disconnect(da);
    }
});

//isolate this for now
(function (window) {
    var MedwebCloud = window.MedwebCloud || {},
        nullStream = "00000000-0000-0000-0000-000000000000";

    function sendStreamCommand(channel, command, stream, type, param, onSuccess, onFailure) {
        if (!stream) {
            stream = fm.guid.empty.toString();
        }
        if (!type) {
            type = "x";
        }
        if (!param) {
            param = "x";
        }
        if (!onSuccess) {
            onSuccess = function () { };
        }
        if (!onFailure) {
            onFailure = function () { };
        }
        var client = MedwebCloud.websyncClient,
            str = command + "\n" + stream + "\n" + type + "\n" + param,
            b64 = window.btoa(unescape(encodeURIComponent(str)));
        console.log("Encoding message to: " + b64);
        client.publish({
            channel: channel,
            data: {
                binary64: b64
            },
            onSuccess: onSuccess,
            onFailure: onFailure
        });
    }

    MedwebCloud.StreamCommands = {
        sendStreamCreate: function (channel, stream, type, param, onSuccess, onFailure) {
            sendStreamCommand(channel, 1, stream, type, param, onSuccess, onFailure);
        },
        sendStreamDestroy: function (channel, stream, type, param, onSuccess, onFailure) {
            sendStreamCommand(channel, 2, stream, type, param);
        },
        sendUserCommand: function (channel, stream, type, param, onSuccess, onFailure) {
            sendStreamCommand(channel, 3, stream, type, param, onSuccess, onFailure);
        },
        sendStreamSubscribed: function (channel, stream, type, param, onSuccess, onFailure) {
            sendStreamCommand(channel, 4, stream, type, param);
        },
    }

    MedwebCloud.generateQRCode = function (jsonStr, success, error, complete) {
        var me = this;

        Ext.Ajax.request({
            url: '/GenerateCode.aspx',
            method: 'POST',
            headers: {
                'Content-Type': 'text/plain', //Mono error for app/json https://bugzilla.xamarin.com/show_bug.cgi?id=6989
            },
            jsonData: jsonStr,
            success: function (response, options) {
                try {
                    var dta = JSON.parse(response.responseText)['data'];
                } catch (e) {
                    console.log("Invalid data returned from GenerateQR: " + response, e);

                    if (error && typeof (error) === 'function') {
                        error(errorDta);
                    }
                    return;
                }

                if (success && typeof (success) === 'function') {
                    success(dta);
                }
            },
            failure: function (response, options) {
                Ext.apply({}, response);

                var responseObj;
                try {    // This will throw if not valid json response
                    responseObj = Ext.decode(response.responseText);
                } catch (e) {
                    console.log("Invalid response to GenerateQR: " + response, e)
                }

                var errorDta = responseObj || response.responseText;

                if (error && typeof (error) === 'function') {
                    error(errorDta);
                }
            },
            callback: function () {
                if (complete && typeof (complete) === 'function') {
                    complete();
                }
            }
        });
    };
}(window));

function onBeforeUnload(e) {
    var showMessage = MedwebCloud.openSessions > 0;
    var MESSAGE = MedwebCloud.getMsg('medweb.beforeunload');

    if (showMessage === true) {
        if (e) e.returnValue = MESSAGE;
        if (window.event) window.event.returnValue = MESSAGE;
        return MESSAGE;
    }
}

//Add subdomain header to all Ext.Ajax requests
Ext.onReady(function () {
    var subdomain = window.location.host.split('.')[0];
    var headers = Ext.apply({}, Ext.Ajax.defaultHeaders || {});
    headers['X-Medweb-Company'] = subdomain;
    Ext.Ajax.defaultHeaders = headers;

    Ext.EventManager.addListener(window, 'beforeunload', onBeforeUnload, this, {
        normalized: false
    });
});