﻿PRV = window.PRV || {};

// Uncomment to force use of the Java applet.
//fm.icelink.webrtc.useApplet = true;

PRV.startVideoChat = function (channel, successCallback) {
    // Log IceLink internals to a DOM container.
    //fm.log.setProvider(new fm.domLogProvider(document.getElementById('log'), fm.logLevel.Info));

    //only start th conference again IF we don't have a conference going. 
    if (!PRV.conference) {
        fm.icelink.webrtc.userMedia.getMedia({
            audio: true,
            video: true,
            defaultVideoPreviewScale: fm.icelink.webrtc.layoutScale.Cover,
            defaultVideoScale: fm.icelink.webrtc.layoutScale.Cover,
            //videoWidth: 320,    // optional
            //videoHeight: 240,   // optional
            //videoFrameRate: 30, // optional
            onFailure: function (e) {
                var msg = MedwebCloud.getMsg('medweb.chat.video.media.error.message', e.getException().message)
                bootbox.alert(msg);
            },
            onSuccess: function (e) {
                PRV.localMedia = e.getLocalStream();
                var localVideoControl = e.getLocalVideoControl();
                PRV.layoutManager = new fm.icelink.webrtc.layoutManager(document.getElementById('videoContainer'));
                PRV.layoutManager.setLocalVideoControl(localVideoControl);
                var audioStream = new fm.icelink.webrtc.audioStream(PRV.localMedia);
                var videoStream = new fm.icelink.webrtc.videoStream(PRV.localMedia);
                videoStream.addOnLinkUp(function (e) {
                    var remoteVideoControl = e.getLink().getRemoteVideoControl();
                    PRV.layoutManager.addRemoteVideoControl(e.getPeerId(), remoteVideoControl);
                });
                videoStream.addOnLinkDown(function (e) {
                    PRV.layoutManager.removeRemoteVideoControl(e.getPeerId());
                });

                var conference = PRV.conference = new fm.icelink.conference(MedwebCloud.serverAddressIceLink, MedwebCloud.serverPortIceLink, [audioStream, videoStream]);
                conference.setRelayUsername('test');
                conference.setRelayPassword('pa55w0rd!');

                conference.addOnLinkInit(function (e) {
                    fm.log.info('ChatVideo.js: Link to peer initializing...\n' + JSON.stringify(e.getPeerState(), null, '\t'));
                });
                conference.addOnLinkUp(function (e) {
                    fm.log.info('ChatVideo.js: Link to peer is UP.\n' + JSON.stringify(e.getPeerState(), null, '\t'));
                });
                conference.addOnLinkDown(function (e) {
                    fm.log.info('ChatVideo.js: Link to peer is DOWN. ' + e.getException().message + '\n' + JSON.stringify(e.getPeerState(), null, '\t'));
                });


                PRV.websyncClient.joinConference({
                    conferenceChannel: channel,
                    conference: conference,
                    onSuccess: function (e) {
                        if (successCallback) successCallback();
                    },
                    onFailure: function (e) {
                        var msg = MedwebCloud.getMsg('medweb.chat.video.join.error.message', e.getConferenceChannel(), e.getException().message);
                        alert(msg);
                    }
                });

            }
        });
    }
};

PRV.endVideoChat = function (channel, successCallback) {
    var leaveFailureCount = 0;
    PRV.websyncClient.leaveConference({
        conferenceChannel: channel,
        onSuccess: function (e) {
            PRV.conference = false;
            if (PRV.localMedia) {
                PRV.localMedia.stop();
            }
            $('#videoContainer').empty();
            if (successCallback) successCallback();
        },
        onFailure: function (e) {
            if (leaveFailureCount >= 10) {
                var msg = MedwebCloud.getMsg('medweb.chat.video.leave.error.message', e.getConferenceChannel(), e.getException().message);
                alert(msg);
            } else {
                e.setRetry(true);
            }
        }
    });
};