﻿Ext.define('MedwebCloud.model.Affiliation', {
    extend: 'Ext.data.Model',
    idProperty: 'Id',
    fields: [
        { name: 'Id', type: 'int', persist: false },
        { name: 'CompanyId', type: 'int' },
        { name: 'CompanyName', type: 'string', mapping: "Company.Name", persist: false },
        { name: 'UserId', type: 'int' },
        { name: 'UserCompanyId', type: 'int', mapping: "User.CompanyId" },
        { name: 'UserCompanyName', type: 'string', mapping: "User.Company.Name", persist: false },
        { name: 'UserName', type: 'string', mapping: "User.Username", persist: false },
        { name: 'UserDisplayName', type: 'string', mapping: "User.DisplayName", persist: false },
        { name: 'IsDoctor', type: 'boolean', mapping: 'User.IsDoctor', persist: false },
        { name: 'DepartmentId', type: 'int' },
        { name: 'DepartmentName', type: 'string', mapping: "Department.Name", persist: false },
        { name: 'CreatedBy', type: 'string', persist: false },
        { name: 'CreatedOn', type: 'date', persist: false, useNull: true },
        { name: 'ModifiedBy', type: 'string', persist: false },
        { name: 'ModifiedOn', type: 'date', persist: false, useNull: true },
    ],
    proxy: {
        type: 'therest',
        url: MedwebCloud.api('/v2/entities/affiliations'),
        reader: {
            type: 'json'
        }
    }
});