Ext.define('MedwebCloud.model.ChatMessage', {
    extend: 'Ext.data.Model',
    idProperty: 'id',
    fields: [
        { name: 'Id', type: 'int' },
        { name: 'ChatId', type: 'auto' },
        { name: 'UserId', type: 'string' },
        { name: 'Text', type: 'string' },
        { name: 'CreatedBy', type: 'string', persist: false },
        { name: 'CreatedOn', type: 'date', persist: false, useNull: true },
        { name: 'ModifiedBy', type: 'string', persist: false },
        { name: 'ModifiedOn', type: 'date', persist: false, useNull: true },
        { name: 'IsDeleted', type: 'boolean' }
    ],
    hasOne: [
        { name: 'Chat', model: 'MedwebCloud.model.Chat', associationKey: 'Chat', getterName: 'getChat', setterName: 'setChat', primaryKey: 'chatId', foreignKey: 'chatMessageId' },
        { name: 'User', model: 'MedwebCloud.v1.model.User', associationKey: 'User', getterName: 'getUser', setterName: 'setUser', primaryKey: 'userId', foreignKey: 'chatMessageId' }
    ]
});