﻿Ext.define('MedwebCloud.view.AffiliationForm2', {
    xtype: 'medwebcloud.affiliationform2',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        var me = this;

        var lblUserName = MedwebCloud.getMsg('medweb.user.email.label');
        var lblDepartment = MedwebCloud.getMsg('medweb.user.department.label');
        var filterer = undefined;

        if (this.customArgs && this.customArgs.CompanyId) {
            //We _don't_ want people from this company, because that would be pointless.
            filterer = [{
                property: 'CompanyId',
                comparison: 'ne',
                value: this.customArgs.CompanyId
            }];
        }

        me.users = Ext.create('MedwebCloud.store.Users', {
            filters: filterer,
            remoteFilter: true
        });

        me.departments = Ext.create('MedwebCloud.store.Departments');
        me.departments.load();

        Ext.apply(me, {
            defaults: {
                anchor: '100%',
                labelWidth: 130
            },
            items: [{
                xtype: 'combo',
                fieldLabel: lblUserName,
                name: 'UserId',
                itemId: 'UserField',
                queryMode: 'remote',
                store: me.users,
                displayField: 'DisplayName',
                valueField: 'Id',
                autoSelect: true,
                forceSelection: true,
                allowBlank: false,
                queryParam: 'include'
            }, {
                xtype: 'combo',
                fieldLabel: lblDepartment,
                name: 'DepartmentId',
                itemId: 'UserDepartmentField',
                queryMode: 'remote',
                store: me.departments,
                displayField: 'Name',
                valueField: 'Id',
                autoSelect: false,
                forceSelection: false,
                allowBlank: true
            }]
        });

        me.callParent(arguments);
    },
    getValues: function () {
        //Customize these return values to populate the record so it *looks* right.

        var userId = this.down('#UserField').value;
        var userRec = this.users.getById(userId);
        var depId = this.down("#UserDepartmentField").value;
        var depRec = this.departments.getById(depId);
        return {
            UserId: userId,
            UserDisplayName: userRec.get("DisplayName"),
            UserName: userRec.get("Username"),
            UserCompanyId: userRec.get("CompanyId"),
            DepartmentId: depId,
            DepartmentName: depRec.get("Name")
        };
    }
});