﻿Ext.define('MedwebCloud.view.Browser', {
    extend: 'Ext.panel.Panel',
    xtype: 'MedwebCloud.browser',

    initComponent: function () {
        var me = this;
        var btnRefresh = MedwebCloud.getMsg('medweb.view.browser.toolbar.refresh.title');
        var plchldUrl = MedwebCloud.getMsg('medweb.view.browser.toolbar.url.placeholder');
        var btnGo = MedwebCloud.getMsg('medweb.view.browser.toolbar.go.title');

        me.iframeId = Ext.id();
        Ext.apply(me, {
            dockedItems: [{
                dock: 'top',
                xtype: 'toolbar',
                items: [{
                    xtype: 'button',
                    text: btnRefresh,
                    handler: me.navigate.bind(me)
                }, {
                    xtype: 'textfield',
                    itemId: 'url',
                    flex: 1,
                    blankText: plchldUrl,
                    enableKeyEvents: true,
                    listeners: {
                        specialkey: function (f, e) {
                            if (e.getKey() == e.ENTER) {
                                me.navigate();
                            }
                        }
                    }
                }, {
                    xtype: 'button',
                    text: btnGo,
                    handler: me.navigate.bind(me)
                }]
            }],
            items: [{
                layout: 'fit',
                border: false,
                html: '<iframe name="' + me.iframeId + '" id="' + me.iframeId + '" src="about:blank" style="border:0;width:100%;height:100%" frameborder="0"></iframe>'
            }]
        });
        me.callParent(arguments);

        me.on('render', function () {
            var frame = document.getElementById(me.iframeId);
            frame.onload = function () {
                me.down('#url').setValue(frame.src);
            };
        });
    },
    navigate: function () {
        var me = this;

        var url = me.down('#url').getValue();
        if (url.indexOf('http') != 0) {
            url = 'http://' + url;
        }
        document.getElementById(me.iframeId).src = url;
    }
});