﻿Ext.define('MedwebCloud.view.DevicesGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'medwebcloud.devicesgrid',

    store: null,

    initComponent: function () {
        if (window.google) {
            var geocoder = new google.maps.Geocoder();
        }
        var me = this;

        me.store = me.store || Ext.create('MedwebCloud.store.Devices', {
            autoLoad: true,
            filters: this.filters,
            expand: this.expand
        });

        Ext.apply(me, {
            store: me.store,
            columns: [{
                dataIndex: 'Id',
                text: 'Id',
                flex: 0.25
            }, {
                dataIndex: 'Name',
                text: 'Name',
                flex: 1
            }, {
                text: 'Location',
                flex: 1,
                renderer: function (value, meta, record) {
                    var location = record.raw.Location;
                    if (location) {
                        if (location.HumanReadable) {
                            return location.HumanReadable;
                        } else {
                            if (window.google) {
                                var latlng = new google.maps.LatLng(location.Latitude, location.Longitude);
                                var id = Ext.id();
                                geocoder.geocode({ 'latLng': latlng }, function (results, status) {
                                    var f = function () {
                                        if (Ext.get(id)) {
                                            if (status == google.maps.GeocoderStatus.OK) {
                                                if (results[1]) {
                                                    Ext.get(id).update(results[1].formatted_address);
                                                } else {
                                                    Ext.get(id).update('No results found');
                                                }
                                            } else {
                                                Ext.get(id).update('Geocoder failed due to: ' + status);
                                            }
                                        }
                                        else {
                                            setTimeout(f, 10);
                                        }
                                    };
                                });
                            } else {
                                return 'No geocoder found';
                            }
                            return '<div id="' + id + '"></div>';
                        }
                    }
                    return ' - ';
                }
            }, {
                xtype:'actioncolumn',
                width: 60,
                items: [{
                    icon: '/images/cfg_glasses.png',
                    iconCls: 'contain-image active-image',
                    tooltip: 'Configure',
                    handler: function(grid, rowIndex, colIndex) {
                        var rec = grid.getStore().getAt(rowIndex);
                        var glasses = [];

                        glasses.push({ id: rec.get('Id'), channel: '/lookingglass/' + rec.get('UniqueId') + '/config' });

                        me.up('[name=lookingglass]').startGlassCfg(glasses);
                    }
                },{
                    icon: '/images/SeeGlasses.png',
                    iconCls: 'contain-image active-image',
                    tooltip: 'View',
                    handler: function(grid, rowIndex, colIndex) {
                        var rec = grid.getStore().getAt(rowIndex);

                        if (MedwebCloud.glassList[rec.get('Id')]) {
                            me.up('[name=lookingglass]').down('#lookingglasspanel').addGlasses(rec);
                        }
                    }
                }]
            }]
        });

        this.callParent(arguments);
    }
});