﻿Ext.define('MedwebCloud.view.InternalChatMapPanel', {
    extend: 'MedwebCloud.view.MapPanel',
    requires: ['MedwebCloud.view.MapPanel'],
    xtype: 'MedwebCloud.internalchatmappanel',
    user: null,
    initComponent: function () {
        var me = this;

        Ext.apply(this, {
            bbar: {
                items: [{
                    xtype: 'tbtext',
                    itemId: 'status',
                    text: ''
                }]
            }
        });

        this.callParent(arguments);

        this.plotUserDevices();
    },
    plotUserDevices: function () {
        var me = this;

        MedwebCloud.v1.model.User.load(this.user.Id, {
            success: function (user) {
                var devices = user.Devices();
                var found = 0;
                devices.each(function (device) {
                    var location = device.get('Location');
                    if (location) {
                        var dt = new Date(Date.parse(location.ModifiedOn));
                        var title = MedwebCloud.getMsg('medweb.view.internalchatmappanel.device.marker.text', user.get('DisplayName'), dt.toLocaleString());

                        me.addPoint(location.Latitude, location.Longitude, title, {
                            moveToPoint: true,
                            icon: MedwebCloud.getGravatarUrl(user.get('Username'), 32)
                        });
                        found++;
                    }
                });

                var status = me.getDockedItems('toolbar[dock="bottom"]')[0].down('#status');
                var bundleName = '';
                if (found > 1) {
                    bundleName = 'medweb.view.internalchatmappanel.device.count.many';
                } else if (found == 1) {
                    bundleName = 'medweb.view.internalchatmappanel.device.count.one';
                } else {
                    bundleName = 'medweb.view.internalchatmappanel.device.count.none';
                }
                status.setText(MedwebCloud.getMsg(bundleName, user.get('DisplayName'), found));
            }
        });
    }
});