﻿Ext.define('MedwebCloud.view.LookingGlassSetupWizard.LookingGlass', {
    xtype: 'medwebcloud.lookingglasssetupwizard.lookingglass',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        Ext.apply(this, {
            defaults: {
                margin: '0 0 20 0',
            },
            items: [{
                xtype: 'panel',
                title: false,
                border: false,
                cls: 'wiz-heading',
                width: '100%',
                html: 'Configure Remote Viewing options:',
            }, {
                xtype: 'panel',
                title: false,
                border: false,
                cls: 'wiz-text',
                width: '100%',
                html: 'Remote Viewing enables Medweb Cloud users to observe and direct remote Looking Glass users.' +
                    '<br /><br />' +
                    'It can also track their location and display it on the map.',
            }, {
                xtype: 'panel',
                layout: {
                    type: 'vbox',
                    pack: 'center',
                    align: 'left',
                },
                padding: '10 10 10 50',
                title: false,
                border: false,
                cls: 'wiz-text',
                width: '100%',
                items: [{
                    xtype: 'checkbox',
                    itemId: 'IsLookingGlassEnabled',
                    name: 'IsLookingGlassEnabled',
                    boxLabel: 'Allow the Glasses to access the Looking Glass service',
                    boxLabelCls: 'wiz-check-label',
                }],
            }, {
                xtype: 'panel',
                layout: {
                    type: 'vbox',
                    pack: 'left',
                    align: 'left',
                },
                padding: '10 10 10 50',
                title: false,
                border: false,
                cls: 'wiz-text',
                width: '100%',
                items: [{
                    xtype: 'checkbox',
                    itemId: 'IsLocationTrackingEnabled',
                    name: 'IsLocationTrackingEnabled',
                    boxLabel: 'Allow the Glasses to send their location for tracking purposes',
                    boxLabelCls: 'wiz-check-label',
                }],
            }],
            listeners: {
                activate: function () {
                    var wiz = this.up('panel').up();
                    this.getForm().getFields().each(function (itm) {
                        var data = wiz.getData(itm.getItemId());
                        if (data != null && data != undefined) {
                            itm.setValue(data);
                        }
                    });
                },
            },
        });

        this.callParent(arguments);
    },
    saveChanges: function () {
        var me = this;

        me.getRecord()['IsLookingGlassEnabled'] = me.down('#IsLookingGlassEnabled').getValue();
        me.getRecord()['IsLocationTrackingEnabled'] = me.down('#IsLocationTrackingEnabled').getValue();
    },
});