﻿Ext.define('MedwebCloud.component.ToggleButton', {
    xtype: 'medwebcloud.togglebutton',
    extend: 'Ext.Panel',

    onState: false,
    labelText: '',
    disabled: false,

    initComponent: function () {
        var me = this;

        me.addEvents('valueChanged');

        Ext.apply(me, {
            layout: 'hbox',
            width: '100%',
            border: false,
            margin: '5 0 0 0',
            items: [{
                xtype: 'label',
                flex: 1,
                text: me.labelText,
                margin: '7 0 0 15',
            }, {
                xtype: 'panel',
                width: 90,
                height: 30,
                border: false,
                header: false,
                html: ['<ul class="wiz-toggle-button">',
                        '<li class="negative',
                        (!me.onState ? ' on' : ''),
                        '"><a name="off">OFF</a></li>',
                        '<li class="positive',
                        (me.onState ? ' on' : ''),
                        '"><a name="on">ON</a></li>',
                      '</ul>'].join(''),
                listeners: {
                    render: function () {
                        me.el.select('li').on('click', function (e) {
                            var li = e.target.tagName.toUpperCase() === 'LI' ? e.target : e.target.parentElement;

                            if (!li.classList.contains('on')) {
                                me.toggle();
                            }
                        });
                    }
                }
            }],
        });

        me.callParent();
    },
    toggle: function (newState) {
        var me = this;

        if (me.disabled) { return; }

        if (typeof (newState) === 'undefined') newState = !me.onState;

        if (newState) {
            me.el.select('li').filter('.positive').addCls('on');
            me.el.select('li').filter('.negative').removeCls('on');
        }
        else {
            me.el.select('li').filter('.positive').removeCls('on');
            me.el.select('li').filter('.negative').addCls('on');
        }

        me.onState = newState;

        me.fireEvent('valueChanged', me.getValue());
    },
    getValue: function () {
        return this.onState;
    },
    setDisabled: function (isDisabled) {
        var me = this;

        if (isDisabled) {
            me.el.select('ul').addCls('disabled');
        } else {
            me.el.select('ul').removeCls('disabled');
        }

        me.disabled = isDisabled;
    }
});