﻿Ext.define('MedwebCloud.view.SupportServerForm2', {
    xtype: 'medwebcloud.supportserverform2',
    extend: 'Ext.form.Panel',

    initComponent: function () {
        var me = this;

        Ext.define("ServerType", {
            extend: 'Ext.data.Model',
            fields: ['name', 'nmbr'],
        });

        me.types = Ext.create('Ext.data.ArrayStore', {
            model: 'ServerType',
            data: [
                ['Medweb EMR', 2],
            ],
            loading: true,
        });

        Ext.apply(me, {
            defaults: {
                anchor: '100%'
            },
            items: [{
                fieldLabel: 'Name',
                name: 'Name',
                xtype: 'textfield',
                allowBlank: false
            }, {
                fieldLabel: 'Url',
                name: 'HostUrl',
                xtype: 'textfield',
                allowBlank: false
            }, {
                fieldLabel: 'Type',
                name: 'ServerType',
                itemId: 'ServerSelect',
                xtype: 'combo',
                queryMode: 'local',
                store: me.types,
                displayField: 'name',
                valueField: 'nmbr',
                value: 2,
                autoSelect: true,
                forceSelection: true,
                editable: false,
                allowBlank: false,
            }],
            listeners: {
                afterrender: function () {
                    var val = this.record.get('ServerType');
                    if (!val) { val = 2; }
                    this.down('#ServerSelect').setValue(val);
                }
            }
        });
        this.callParent(arguments);
    }
});