﻿Ext.define('MedwebCloud.view.User.Form', {
    xtype: 'medwebcloud.user.form',
    extend: 'MedwebCloud.view.ItemForm',
    initComponent: function () {
        var me = this;

        var me = this;

        var lblDisplay = MedwebCloud.getMsg('medweb.user.displayname.label');
        var lblPassConf = MedwebCloud.getMsg('medweb.user.password.confirm.label');
        var lblUserName = MedwebCloud.getMsg('medweb.user.email.label');
        var lblPass = MedwebCloud.getMsg('medweb.user.password.label');
        var lblTrack = MedwebCloud.getMsg('medweb.user.tracking.label');
        var lblTZ = MedwebCloud.getMsg('medweb.user.preferredtimezone.label');
        var lblLang = MedwebCloud.getMsg('medweb.user.language.label');
        var lblDoctor = MedwebCloud.getMsg('medweb.user.isdoctor.label');
        var lblDepartment = MedwebCloud.getMsg('medweb.user.department.label');

        me.departments = Ext.create('MedwebCloud.store.Departments');
        me.departments.load();
        var zones = Ext.create('Ext.data.Store', {
            fields: ['Id', 'DisplayName'],
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json',
                    root: ''
                }
            },
            data: MedwebCloud.UIConfig.Timezones
        });

        var langs = Ext.create('Ext.data.Store', {
            fields: ['Name', 'DisplayName'],
            proxy: {
                type: 'memory',
                reader: {
                    type: 'json'
                }
            },
            data: MedwebCloud.UIConfig.SupportedCultures
        });
        Ext.apply(me, {
            defaults: {
                anchor: '100%',
                labelWidth: 130
            },
            items: [{
                xtype: 'textfield',
                fieldLabel: lblUserName,
                allowBlank: false,
                name: 'Username'
            }, {
                xtype: 'textfield',
                fieldLabel: lblDisplay,
                allowBlank: false,
                name: 'DisplayName'
            }, {
                xtype: 'textfield',
                fieldLabel: lblPass,
                inputType: 'password',
                itemId: 'Password',
                name: 'Password'
            }, {
                xtype: 'textfield',
                fieldLabel: lblPassConf,
                inputType: 'password',
                vtype: 'password',
                initialPassField: 'Password',
                name: 'ConfirmPassword'
            }, {
                xtype: 'checkbox',
                fieldLabel: lblDoctor,
                name: 'IsDoctor'
            }, {
                xtype: 'combo',
                fieldLabel: lblDepartment,
                name: 'DepartmentId',
                queryMode: 'remote',
                store: me.departments,
                displayField: 'Name',
                valueField: 'Id',
                autoSelect: false,
                forceSelection: false,
                allowBlank: true
            }, {
                xtype: 'checkbox',
                fieldLabel: lblTrack,
                name: 'TrackLocation'
            }, {
                xtype: 'combo',
                fieldLabel: lblLang,
                name: 'Language',
                queryMode: 'local',
                store: langs,
                displayField: 'DisplayName',
                valueField: 'Name',
                autoSelect: true,
                forceSelection: true,
                //TODO: if this is going to be used *ANYWHERE* else, move it into a "help" option on all fields
                afterLabelTextTpl: ' <img src="../../../images/help.png" class="info_image" data-qtip="Requires logging out and back in again"></img>'
            }, {
                xtype: 'combo',
                fieldLabel: lblTZ,
                name: 'PreferredTimezone',
                queryMode: 'local',
                store: zones,
                displayField: 'DisplayName',
                valueField: 'Id',
                autoSelect: true,
                forceSelection: true
            }],

            listeners: {
                load: function (record) {
                    me.setTitle(record.get("DisplayName"))
                    var username = me.items.getAt(0);
                    if (record.phantom) {
                        username.enable();
                    } else {
                        username.disable();
                    }
                },
                save: function (record) {
                    me.setTitle(record.get("DisplayName"))
                    var username = me.items.getAt(0);
                    if (record.phantom) {
                        username.enable();
                    } else {
                        username.disable();
                    }
                }
            }
        });

        this.callParent(arguments);
    }
});