﻿Ext.define('MedwebCloud.view.Users.Grid', { //Note slight change in naming convention to avoid conflicts.
    extend: 'Ext.grid.Panel',
    xtype: 'medwebcloud.users.grid',
    requires: ['Ext.util.DelayedTask'],

    initComponent: function () {
        var me = this;
        var colName = MedwebCloud.getMsg('medweb.view.usergrid.column.name.title');
        var colUser = MedwebCloud.getMsg('medweb.view.usergrid.column.username.title');

        me.doQuery = new Ext.util.DelayedTask(function filter(term) {
            var store = me.getStore();
            if (term.length) {
                store.load({
                    params: { Include: term }
                });
            } else {
                store.load();
            }
        })

        var tbar = me.tbar || [];

        if (tbar.length > 0) {
            tbar.push('-');
        }
        tbar.push({
            xtype: 'textfield',
            border: false,
            emptyText: 'Search',
            flex: 1,
            listeners: {
                render: function () {
                    var me = this;
                    me.ownerCt.on('resize', function () {
                        me.setWidth(this.getEl().getWidth() - 15);
                    });
                },
                change: function (textField, value) {
                    me.doQuery.delay(500, null, null, [value]);
                },
                blur: function (textfield) {
                    me.doQuery.delay(500, null, null, [textfield.getValue()]);
                }
            }
        });

        Ext.apply(me, {
            store: Ext.create('MedwebCloud.store.Users', {
            }),
            tbar: tbar,
            columns: [{
                dataIndex: 'DisplayName',
                text: colName,
                flex: 2
            }, {
                dataIndex: 'Username',
                text: colUser,
                flex: 1
            }]
        });

        this.callParent(arguments);
    }
});