﻿/*
***TODO: I18N in this file***
*/

Ext.define('MedwebCloud.view.WaitingRoom.AssignedChatsGrid', {
    extend: 'Ext.grid.Panel',
    xtype: 'MedwebCloud.wr.assignedchatsgrid',
    loadMask: true,
    activeChatsStore: null,

    initComponent: function () {
        var me = this;

        Ext.eventBus.on('waitingroomchatrequestassigned', function (e) {
            me.recieveChat(e.getData().From, e.getData().ChatRequest);
        });

        var columnNameTitle = MedwebCloud.getMsg('medweb.waitingroom.assignedchats.grid.column.name.title');
        var columnEmailTitle = MedwebCloud.getMsg('medweb.waitingroom.requests.grid.column.email.title');
        var columnIDTitle = MedwebCloud.getMsg('medweb.waitingroom.requests.grid.column.id.title');
        var columnTotalTitle = MedwebCloud.getMsg('medweb.waitingroom.assignedchats.grid.column.totaltime.title');

        var columnActionTitle = MedwebCloud.getMsg('medweb.waitingroom.assignedchats.grid.column.action.title');
        var columnActionTooltip = MedwebCloud.getMsg('medweb.waitingroom.assignedchats.grid.column.action.start.tooltip');

        Ext.apply(me, {
            store: Ext.create('MedwebCloud.store.ChatRequests', {}),
            autoHeight: true,
            columns: [
				{
				    dataIndex: 'DisplayName',
				    text: columnNameTitle,
				    flex: 1
				}, {
				    dataIndex: 'Email',
				    text: columnEmailTitle,
				    width: 80
				}, {
				    dataIndex: 'Identifier',
				    text: columnIDTitle,
				    width: 80
				}, {
				    text: columnTotalTitle,
				    dataIndex: 'ModifiedOn',
				    width: 75,
				    renderer: function (value, meta, record) {
				        var now = new Date();
				        var milliseconds = now - value;

				        var x = milliseconds / 1000;
				        var seconds = ~~(x % 60); x /= 60;
				        var minutes = ~~(x % 60); x /= 60;
				        var hours = ~~(x % 24); x /= 24;
				        var days = ~~(x);

				        var dayFmt = MedwebCloud.getMsg('medweb.waitingroom.activechats.grid.column.elapsedtime.format.day', days);
				        var hrsFmt = MedwebCloud.getMsg('medweb.waitingroom.activechats.grid.column.elapsedtime.format.hrs', hours);
				        var minFmt = MedwebCloud.getMsg('medweb.waitingroom.activechats.grid.column.elapsedtime.format.min', minutes);
				        var secFmt = MedwebCloud.getMsg('medweb.waitingroom.activechats.grid.column.elapsedtime.format.sec', seconds);

				        return (days >= 1 ? dayFmt + ' ' : '') +
                            (hours >= 1 ? hrsFmt + ' ' : '') +
                            (minutes >= 1 ? minFmt + ' ' : '') +
                            (seconds >= 1 ? secFmt + ' ' : '');
				    }
				}, {
				    xtype: 'actioncolumn',
				    text: columnActionTitle,
				    width: 40,
				    items: [{
				        iconCls: 'startIcon',
				        tooltip: columnActionTooltip,
				        handler: function (grid, rowIndex, colIndex, item, e, record, row) {
				            me.fireEvent('startChat', {
				                chat: record.getChat(),
				                chatRequest: record
				            });
				        }
				    }]
				}
            ]
        });

        me.callParent(arguments);
    },
    recieveChat: function (from, chatRequest) {
        var me = this;

        // build and add the record
        var record = Ext.create('MedwebCloud.model.ChatRequest', chatRequest);
        record.setChat(Ext.create('MedwebCloud.model.Chat', chatRequest.Chat));
        this.store.add(record);

        Ext.Msg.toast({
            body: 'You have been assigned a patient by ' + from.DisplayName,
            handler: function () {
                me.fireEvent('startChat', {
                    chat: record.getChat(),
                    chatRequest: record
                });
            }
        });
    },
    parseRawRecords: function (data) {
        var me = this;
        var result = me.activeChatsStore.getProxy().getReader().read(data);

        return result.records;
    }
});