﻿/*
***TODO: I18N in this file***
*/

Ext.define('MedwebCloud.view.WaitingRoom.ChatPanel', {
    extend: 'Ext.panel.Panel',
    xtype: 'MedwebCloud.wr.chatpanel',
    requires: ['MedwebCloud.view.WaitingRoom.SugarPanel', 'MedwebCloud.view.Browser'],
    chat: null,
    chatRequest: null,

    chatSurface: null,
    layoutManager: null,
    client: null,
    initComponent: function () {
        var me = this;
        var channel = me.chat.get('Channel');
        var active = true;

        var labels = {
            waiting: MedwebCloud.getMsg('medweb.view.waitingroom.waiting.label'),
            active: MedwebCloud.getMsg('medweb.view.waitingroom.active.label'),
            displayname: MedwebCloud.getMsg('medweb.view.waitingroom.displayname.label'),
            sessions: MedwebCloud.getMsg('medweb.view.waitingroom.sessions.label'),
            code: MedwebCloud.getMsg('medweb.view.waitingroom.code.label'),
            assignedtome: MedwebCloud.getMsg('medweb.view.waitingroom.assignedtome.label'),
            endchat: MedwebCloud.getMsg('medweb.view.waitingroom.endchat.label'),
            placecall: MedwebCloud.getMsg('medweb.view.waitingroom.placecall.label'),
            schedule: MedwebCloud.getMsg('medweb.view.waitingroom.schedule.label'),
            startvideo: MedwebCloud.getMsg('medweb.view.waitingroom.startvideo.label'),
            endvideo: MedwebCloud.getMsg('medweb.view.waitingroom.endvideo.label'),
            showscreen: MedwebCloud.getMsg('medweb.view.waitingroom.showscreen.label'),
            transferfile: MedwebCloud.getMsg('medweb.view.waitingroom.transferfile.label'),
            mutevideo: MedwebCloud.getMsg('medweb.view.waitingroom.mutevideo.label'),
            muteaudio: MedwebCloud.getMsg('medweb.view.waitingroom.muteaudio.label'),
            send: MedwebCloud.getMsg('medweb.view.waitingroom.send.label'),
            sharescreen: MedwebCloud.getMsg('medweb.view.waitingroom.sharescreen.label')
        };

        me.chatSurface = Ext.create('Ext.panel.Panel', {
            border: false,
            cls: 'chatSurface',
            itemId: 'chatSurface',
            autoScroll: true
        });

        me.client.join({
            channel: channel,
            userId: '' + MedwebCloud.userProfile.Id,
            userNickname: MedwebCloud.userProfile.DisplayName || MedwebCloud.userProfile.Username,
            handled: true,
            onSuccess: function (e) {
                var pastMessages = fm.json.deserialize(e.getExtensionValueJson('messages'));

                for (var i = 0; i < pastMessages.length; i++) {
                    var userName = (pastMessages[i].User) ? (pastMessages[i].User.DisplayName || pastMessages[i].User.Username) : me.chatRequest.get('Name');
                    me.addChatMessage(pastMessages[i].Id, pastMessages[i].Text, userName);
                }

                me.scrollChatToBottom();
                MedwebCloud.openSessions += 1;

                //var users = e.getUsers();
                //for (var i = 0; i < users.length; i++) {
                //    Ext.Msg.alert('Notice', users[i].getUserNickname());
                //}
            },
            onFailure: function (e) {
                Ext.Msg.alert('Error', 'Failed to join chat');
                console.log('Error on channel: ' + channel);
                console.log(e.getException().message);
            },
            onReceive: function (e) {
                if (!active) {
                    return;
                }
                var fromMe = e.getWasSentByMe();
                var data = e.getData();
                if (data.notice && !fromMe) {
                    me.processNotice(data.notice, e);
                    return;
                }
                if (data.message) {
                    var publishingUser = e.getPublishingUser();
                    var username = publishingUser.getUserNickname();

                    username = username === 'user' ? me.chatRequest.get('DisplayName') : username;
                    username = username || me.chatRequest.get('Identifier');
                    me.addChatMessage(data.id, data.message, username);
                    if (!fromMe) {
                        soundManager.play('beep');
                    }
                }
            },
            onUserJoin: function (e) {
                if (!active) {
                    return;
                }

                //var username = e.getJoinedUser().getUserNickname();
                //Ext.Msg.alert('Error', username + ' joined the chat');
            },
            onUserLeave: function (e) {
                if (!active) {
                    return;
                }
                //var username = e.getLeftUser().getUserNickname();
                //Ext.Msg.alert('Error', username + ' left the chat');
                var username = e.getLeftUser().getUserNickname();
                username = username === 'user' ? me.chatRequest.get('Name') : username;
                me.addChatNotice(username + " has left the chat.");
            }
        });

        var evisitPanels = [{
            title: 'JLV',
            border: false,
            xtype: 'component',
            itemId: 'sugarFrame',
            autoEl: {
                tag: "iframe",
                src: "https://home.jerodandangela.com/JLV/app/index"
            }
        }, {
            title: 'CHCS',
            border: false,
            xtype: 'component',
            autoScroll: true,
            html: '<img src="/images/screenshots/chcs.png" />'
        }, {
            title: 'VISTA',
            border: false,
            hidden: true,
            xtype: 'component',
            autoEl: {
                tag: "img",
                src: "#"
            }
        }, {
            title: 'Medweb Server',
            border: false,
            xtype: 'component',
            autoScroll: true,
            autoEl: {
                tag: 'iframe',
                src: 'https://demo.medweb.com/wavelet/study_list.2.0.cgi?find_where=0&substring=Randall'
            }
        }, {
            title: 'Medweb Prescriptions',
            border: false,
            xtype: 'component',
            autoScroll: true,
            autoEl: {
                tag: 'iframe',
                src: '/handlers/DoseSpotLogin.ashx?FirstName=Rick&LastName=Johnson&DateOfBirth=2001-01-24&Gender=Male&Address1=716%20Main%20Street&City=Waltham&State=Massachusetts&ZipCode=02451&PrimaryPhone=781%20777-7777&PrimaryPhoneType=Home'
            }
        }];

        if (MedwebCloud.userProfile.Company.EVisitLinks != null && MedwebCloud.userProfile.Company.EVisitLinks.length > 0) {
            evisitPanels = [];
            for (var i = 0; i < MedwebCloud.userProfile.Company.EVisitLinks.length; i++) {
                var link = MedwebCloud.userProfile.Company.EVisitLinks[i];
                if (!link.Enabled || link.IsDeleted) {
                    continue;
                }
                var config = {
                    title: link.Name,
                    border: false,
                    xtype: 'component',
                    autoScroll: true,
                    autoEl: {
                        tag: 'iframe',
                        sandbox: 'allow-same-origin allow-scripts allow-popups allow-forms',
                        src: link.Url
                    }
                };
                if (link.Url.endsWith('.png') || link.Url.endsWith('.jpg') || link.Url.endsWith('.jpeg')) {
                    delete config.autoEl;
                    config.html = '<img src="' + link.Url + '" />'
                }
                evisitPanels.push(config);
            }
        }

        var tbar = [{
            xtype: 'button',
            text: labels.endchat,
            iconCls: 'endIcon',
            handler: function () {
                Ext.Msg.confirm('Are you sure?', 'Are you sure you want to end this chat?', function (btn) {
                    if (btn === 'yes') {
                        me.endChat();
                    }
                });
            }
        }, {
            xtype: 'button',
            text: labels.schedule,
            iconCls: 'calendar2Icon',
            itemId: 'scheduleBtn',
            handler: function (btn) {
                //invoke schedule call screen
                console.log("schedule a call...");
                var me = this;
                var w;
                var failure = function () {
                    Ext.Msg.alert(MedwebCloud.getMsg('medweb.view.collagepanel.action.schedule.error.title'), MedwebCloud.getMsg('medweb.view.collagepanel.action.schedule.error.message'));
                };
                var succes = function () {
                    w.close();
                };

                var btnText = MedwebCloud.getMsg('medweb.view.collagepanel.action.schedule.button.positive.label');
                w = new Ext.Window({
                    center: true,
                    height: 600,
                    width: 600,
                    border: false,
                    modal: true,
                    layout: 'fit',
                    closable: true,
                    title: 'Schedule a Session',
                    items: [{
                        xtype: 'MedwebCloud.schedulesessionpanel',
                        itemId: 'schedule',
                    }
                    ],
                    buttons: [{
                        text: btnText,
                        itemId: 'scheduleButton',
                        disabled: true,
                        handler: function () {
                            var sp = w.getComponent('schedule');
                            if (sp != null) {
                                sp.createSession();
                            }
                            w.close();
                        }
                    }]
                });
                w.show();
            }
        }, {
            xtype: 'button',
            text: labels.placecall,
            iconCls: 'callIcon',
            itemId: 'placeCallBtn',
            disabled: !me.chatRequest.get('IsSMS'),
            tooltip: !me.chatRequest.get('IsSMS') ? 'This user does not support phone calls' : 'Place call',
            handler: function (btn) {
                var number = me.chatRequest.get('Identifier');
                me.placeCall(number);
            }
        }, {
            xtype: 'button',
            text: labels.startvideo,
            iconCls: 'videoIcon',
            itemId: 'startVideoBtn',
            disabled: !me.chatRequest.get("IsVideoSupported"),
            tooltip: !me.chatRequest.get("IsVideoSupported") ? 'This user\'s browser does not support video chat' : 'Start Video',
            handler: function (btn) {
                if (me.startVideo()) {
                    me.sendNotice({
                        notice: 'videoStart',
                        onFailure: function (e) {
                            Ext.Msg.alert('Error', 'An error occurred while starting the video chat.');
                            console.log(e.getException().message);
                        }
                    });
                }
            }
        }, {
            xtype: 'button',
            text: labels.endvideo,
            iconCls: 'videoIcon',
            itemId: 'endVideoBtn',
            hidden: true,
            handler: function (btn) {
                me.endVideo();
                me.sendNotice({
                    notice: 'videoEnd',
                    onFailure: function (e) {
                        Ext.Msg.alert('Error', 'An error occurred while ending the video chat.');
                        console.log(e.getException().message);
                    }
                });
            }
        }, {
            xtype: 'button',
            text: labels.showscreen,
            iconCls: 'showScreenIcon',
            tooltip: 'This feature is not yet available',
            disabled: true
        }, {
            xtype: 'button',
            text: labels.transferfile,
            iconCls: 'fileTransferIcon',
            tooltip: 'This feature is not yet available',
            disabled: true
        }];

        var chatRequest = me.chatRequest.raw;
        var chatRequestDataHtml = me.chatRequest.getHTML();

        Ext.apply(me, {
            layout: 'border',
            listeners: {
                beforeclose: function (panel) {
                    MedwebCloud.openSessions -= 1;

                    var chan = panel.chat.get('Channel');
                    panel.endVideo();
                    active = false;
                    panel.sendNotice({
                        notice: 'videoEnd',
                        onFailure: function (e) {
                            Ext.Msg.alert('Error', 'An error occurred while ending the video chat.');
                            console.log(e.getException().message);
                        },
                        onSuccess: function (e) {
                            panel.client.leave({
                                channel: chan,
                                onSuccess: function (e) {
                                },
                                onFailure: function (e) {
                                }
                            });
                        }
                    });
                    return true;
                }
            },
            tbar: tbar,
            items: [{
                region: 'west',
                width: 400,
                //split: true,
                //stateful: true,
                //stateId: 'videoContainer',
                split: true,
                border: false,
                layout: 'border',
                items: [{
                    region: 'north',
                    height: 125,
                    border: false,
                    overflowY: 'auto',
                    html: chatRequestDataHtml
                }, {
                    region: 'center',
                    layout: 'vbox',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    border: false,
                    items: [
                        Ext.apply(me.chatSurface, { flex: 1 }),
                    {
                        xtype: 'splitter'
                    }, {
                        //frame: true,
                        border: false,
                        hidden: true,
                        split: true,
                        flex: 2,
                        //html: 'jerod',
                        //title: 'Video Chat',
                        itemId: 'videoContainer',
                        listeners: {
                            resize: function () {
                                if (me.layoutManager) {
                                    me.layoutManager.doLayout();
                                }
                            }
                        },
                        dockedItems: [{
                            xtype: 'toolbar',
                            dock: 'top',
                            hidden: true,
                            items: [{
                                xtype: 'button',
                                text: labels.mutevideo,
                                iconCls: 'videoMuteIcon',
                                enableToggle: true,
                                toggleHandler: function (btn, pressed) {
                                    if (pressed) { me.localMedia.muteVideo(); }
                                    else { me.localMedia.unmuteVideo(); }
                                }
                            }, {
                                xtype: 'button',
                                text: labels.muteaudio,
                                iconCls: 'audioMuteIcon',
                                enableToggle: true,
                                toggleHandler: function (btn, pressed) {
                                    if (pressed) { me.localMedia.muteAudio(); }
                                    else { me.localMedia.unmuteAudio(); }
                                }
                            }]
                        }]
                    }]
                }, {
                    region: 'south',
                    height: 60,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [{
                        border: false,
                        layout: {
                            type: 'hbox',
                            align: 'stretch'
                        },
                        padding: 5,
                        //height: 60,
                        items: [{
                            xtype: 'textarea',
                            itemId: 'chatMessageText',
                            height: 50,
                            flex: 3,
                            enableKeyEvents: true,
                            listeners: {
                                keydown: function (tf, e, eOpts) {
                                    if (e.getKey() == e.SHIFT) {
                                        this.shiftPressed = true;
                                    }
                                },
                                keyup: function (tf, e, eOpts) {
                                    if (this.shiftPressed && (e.getKey() == e.ENTER)) {
                                        e.stopEvent();
                                    }
                                    else if (e.getKey() == e.ENTER) {
                                        this.shiftPressed = false;
                                        me.sendMessageHandler();
                                    }
                                    else { this.shiftPressed = false; }
                                }
                            }
                        }, {
                            xtype: 'button',
                            text: labels.send,
                            cls: 'sendButton',
                            height: 50,
                            flex: 1,
                            handler: Ext.Function.bind(me.sendMessageHandler, me)
                        }]
                    }, {
                        border: false,
                        title: 'Contact',
                        height: 180,
                        hidden: true,
                        chatRequest: this.chatRequest,
                        xtype: 'MedwebCloud.wr.sugarpanel',
                        listeners: {
                            entityShown: function (entity, type) {
                                // hacked in to login dialog to deal w/ iframing issue here:
                                // [sugar root]/include/MVC/View/tpls/sidecar.tpl
                                /*var url = 'http://sugar.medweb.net/sugarcrm/#' + (type == 'contact' ? 'Contacts' : 'Leads') + '/' + entity.id;
                                //console.log(url);
                                var container = me.down('#sugarFrame');
                                container.getEl().dom.src = url;

                                me.down('#panels').setActiveTab(container);*/
                            }
                        }
                    }]
                }]
            }, {
                region: 'center',
                //layout: 'tabpanel',
                xtype: 'tabpanel',
                itemId: 'panels',
                deferredRender: false,
                border: false,
                items: evisitPanels
            }]
        });
        me.callParent(arguments);
    },
    enableVideo: function (clientId) {
        this.down('#startVideoBtn').enable();
        this.down('#endVideoBtn').enable();
    },
    addChatMessage: function (id, message, username) {
        var me = this;

        var formats = "(999)999-9999|999-999-9999|9999999999";
        var r = RegExp("(" +
               formats
                 .replace(/([\(\)])/g, "\\$1")
                 .replace(/9/g, "\\d") +
               ")");

        if (message.match(r)) {
            var number = message.match(r)[0];
            message = message.replace(r, '<a href="#" onclick="Ext.getCmp(\'' + me.getId() + '\').placeCall(\'' + number + '\');return false;">$1</a>');
        }

        if (Ext.get('chatmessage_' + id)) {
            return;
        }
        var chatMessage =
            '<div id="chatmessage_' + id + '" class="chatMessage">' +
                '<span class="chatUsername">' + username + ':</span>' +
                '<span>' + message + '</span>' +
            '</div>';

        me.chatSurface.add({
            border: false,
            html: chatMessage
        });

        me.scrollChatToBottom();
    },
    addChatNotice: function (message) {
        var me = this;

        var chatMessage =
            '<div class="chatNotice">' +
                '<span>' + message + '</span>' +
            '</div>';

        me.chatSurface.add({
            border: false,
            html: chatMessage
        });

        me.scrollChatToBottom();
    },
    placeCall: function (number) {
        var btn = this.down('#placeCallBtn');
        if (btn.callInProgress) {
            Twilio.Device.disconnectAll();
        } else {
            // for SMS chats, the phone number is stored in the identifier field
            Twilio.Device.connect({
                PhoneNumber: number
            });
            btn.setText('Calling...');
            btn.disable();
            btn.callInProgress = true;
        }

        // hook up the twilio events
        if (!btn.hookedUp) {
            btn.hookedUp = true;
            Twilio.Device.error(function (error) {
                btn.setText('Place Call');
                Ext.Msg.alert('Error', error.message);
            });
            Twilio.Device.connect(function (conn) {
                btn.setText('End Call');
                btn.enable();
            });
            Twilio.Device.disconnect(function (conn) {
                btn.setText('Place Call');
                btn.enable();
                btn.callInProgress = false;
            });
        }
    },
    sendMessage: function (message) {
        var me = this;
        var channel = me.chat.get('Channel');
        me.client.publish({
            channel: channel,
            data: {
                message: message,
                username: MedwebCloud.userProfile.UserName
            },
            onSuccess: function (e) {
            },
            onFailure: function (e) {
                Ext.Msg.alert('Error', 'Error sending message.');
                console.log('Could not send data to ' + channel);
                console.log(e.getException().message);
            }
        });
    },
    sendNotice: function (args) {
        var me = this;
        if (!args || !args.notice) {
            return;
        }

        me.client.publish({
            channel: '/waitingroom/chat/' + me.chat.get('Id'),
            data: {
                notice: args.notice
            },
            onSuccess: args.onSuccess,
            onFailure: args.onFailure
        });
    },
    sendMessageHandler: function () {
        var me = this;

        var message = me.down('#chatMessageText').getValue();
        me.down('#chatMessageText').setValue('');
        if (message != null && message.trim() != '') {
            me.sendMessage(message);
        }
    },
    scrollChatToBottom: function () {
        var me = this;
        var cmp = me.down('#chatSurface');
        if (cmp) {
            var chatBodyDom = cmp.body.dom;
            chatBodyDom.scrollTop = chatBodyDom.scrollHeight - chatBodyDom.offsetHeight;
        }
    },
    processNotice: function (notice, e) {
        var me = this;
        switch (notice) {
            case 'hasVideo':
                me.enableVideo();
                break;
            case 'videoStart':
                me.startVideo();
                me.addChatNotice("User has requested a video chat.")
                break;
            case 'videoEnd':
                // debugger;
                me.endVideo(e);
                me.addChatNotice("User has ended the video chat.")
                break;
            case 'transferChat':
                me.endVideo();
                me.close();
                break;
            default:
                break;
        }
    },
    startVideo: function () {
        var me = this;
        if (!me.conference) {
            fm.icelink.webrtc.screenshare.deactivate();
            fm.icelink.webrtc.userMedia.getMedia({
                audio: true,
                video: true,
                defaultVideoPreviewScale: fm.icelink.webrtc.layoutScale.Cover,
                defaultVideoScale: fm.icelink.webrtc.layoutScale.Cover,
                //videoWidth: 320,    // optional
                //videoHeight: 240,   // optional
                //videoFrameRate: 30, // optional
                onFailure: function (e) {
                    alert('Could not get media. ' + e.getException().message);
                    me.localMedia = false;
                },
                onSuccess: function (e) {
                    var panel = me.up('tabpanel');
                    if (!!panel) {
                        panel.setActiveTab(me);
                        me.localMedia = e.getLocalStream();
                        me.localVideoControl = e.getLocalVideoControl();

                        me.initializeVideo();
                    }
                }
            });
        }
        return true;
    },
    getVideoContainerElement: function () {
        var me = this;
        // Need to grab the x-panel-body, not the x-panel
        var cmp = me.down('#videoContainer');
        var container = cmp ? cmp.body.dom.firstChild.firstChild : null;

        if (container) {
            container.style.display = 'block';
            if (container.parentNode) {
                container.parentNode.style.display = 'block';
            }
        }
        return container;
        //debugger
        //return cmp ? cmp.getEl().dom.lastChild : null;
    },
    setVideoControlsVisibility: function (visible) {
        var me = this;
        var container = me.down('#videoContainer');
        if (container) {
            container.setVisible(visible);
            container.getDockedItems('toolbar[dock="top"]')[0].setVisible(visible);
        }
        this.scrollChatToBottom();

        me.doLayout();
    },
    initializeVideo: function () {
        var me = this;
        var channel = '/waitingroom/video/' + me.chat.get('Id');

        me.setVideoControlsVisibility(true);

        //if (!me.layoutManager) {
        me.layoutManager = new fm.icelink.webrtc.layoutManager(me.getVideoContainerElement());
        me.layoutManager.setLocalVideoControl(me.localVideoControl);
        //}

        var audioStream = new fm.icelink.webrtc.audioStream(me.localMedia);
        var videoStream = new fm.icelink.webrtc.videoStream(me.localMedia);
        videoStream.addOnLinkUp(function (e) {
            var remoteVideoControl = e.getLink().getRemoteVideoControl();
            me.layoutManager.addRemoteVideoControl(e.getPeerId(), remoteVideoControl);
        });
        videoStream.addOnLinkDown(function (e) {
            me.layoutManager.removeRemoteVideoControl(e.getPeerId());
        });

        var conference = this.conference = new fm.icelink.conference(MedwebCloud.serverAddressIceLink, MedwebCloud.serverPortIceLink, [audioStream, videoStream]);
        conference.setRelayUsername('test');
        conference.setRelayPassword('pa55w0rd!');

        conference.addOnLinkInit(function (e) {
            fm.log.info('WaitingRoom/ChatPanel.js: Link to peer initializing...\n' + JSON.stringify(e.getPeerState(), null, '\t'));
        });
        conference.addOnLinkUp(function (e) {
            fm.log.info('WaitingRoom/ChatPanel.js:VideoPanel.js: Link to peer is UP.\n' + JSON.stringify(e.getPeerState(), null, '\t'));
        });
        conference.addOnLinkDown(function (e) {
            fm.log.info('WaitingRoom/ChatPanel.js:VideoPanel.js: Link to peer is DOWN. ' + e.getException().message + '\n' + JSON.stringify(e.getPeerState(), null, '\t'));
        });

        me.client.joinConference({
            conferenceChannel: channel,
            conference: conference,
            onSuccess: function (e) {
                me.down('#startVideoBtn').setVisible(false);
                me.down('#endVideoBtn').setVisible(true);
            },
            onFailure: function (e) {
                Ext.Msg.alert('Could not join conference ' + e.getConferenceChannel() + '. ' + e.getException().message);
            }
        });
    },
    endVideo: function () {
        var me = this;
        var channel = '/waitingroom/video/' + me.chat.get('Id');

        if (me.conference) {
            try {
                var failureCount = 0;
                me.client.leaveConference({
                    conferenceChannel: channel,
                    onSuccess: function (e) {
                        me.conference = null;
                        if (me.localMedia) {
                            me.localMedia.stop();
                            var container = me.getVideoContainerElement();
                            if (!!container) {
                                //document.getElementById('videoContainer').innerHTML = '';
                                me.getVideoContainerElement().innerHTML = '';
                                //me.layoutManager.reset();
                            }
                            me.setVideoControlsVisibility(false);
                            container = me.down('#startVideoBtn');
                            if (!!container) {
                                container.setVisible(true);
                            }
                            container = me.down('#endVideoBtn');
                            if (!!container) {
                                container.setVisible(false);
                            }
                        }
                        //MedwebCloud.activeVideoChatPanel = null;
                    },
                    onFailure: function (e) {
                        if (failureCount >= 10) {
                            alert('Could not leave conference ' + e.getConferenceChannel() + '. ' + e.getException().message);
                            return;
                        } else {
                            e.setRetry(true);
                            failureCount += 1;
                        }
                    }
                });
            } catch (e) {
                // ignore it
            }
        }
    },
    endChat: function () {
        var me = this;

        //if (MedwebCloud.activeVideoChatPanel == me) {
        me.endVideo();
        //}

        me.sendNotice({
            notice: 'endChat',
            onSuccess: function (e) {
                me.close();
            },
            onFailure: function (e) {
                Ext.Msg.alert('Error', 'An error occurred while attempting to end the chat.');
                console.log(e.getException().message);
            }
        });

        me.fireEvent('endChat');
    }
});