﻿/*
***TODO: I18N in this file***
*/
Ext.define('MedwebCloud.view.WaitingRoom.ChatsSection', {
    extend: 'Ext.panel.Panel',
    xtype: 'MedwebCloud.wr.chatssection',
    requires: [
        'MedwebCloud.view.WaitingRoom.ChatRequestsGrid',
        'MedwebCloud.view.WaitingRoom.ActiveChatsGrid',
        'MedwebCloud.view.WaitingRoom.ChatPanel',
        'MedwebCloud.view.WaitingRoom.AssignedChatsGrid',
        'MedwebCloud.view.WaitingRoom.DoctorsGrid',
        'MedwebCloud.view.WaitingRoom.SessionsGrid'
    ],
    client: null,
    initComponent: function () {
        var me = this;

        var labels = {
            waiting: MedwebCloud.getMsg('medweb.view.waitingroom.waiting.label'),
            active: MedwebCloud.getMsg('medweb.view.waitingroom.active.label'),
            doctors: MedwebCloud.getMsg('medweb.view.waitingroom.doctors.label'),
            displayname: MedwebCloud.getMsg('medweb.view.waitingroom.displayname.label'),
            sessions: MedwebCloud.getMsg('medweb.view.waitingroom.sessions.label'),
            code: MedwebCloud.getMsg('medweb.view.waitingroom.code.label'),
            assignedtome: MedwebCloud.getMsg('medweb.view.waitingroom.assignedtome.label'),
            endchat: MedwebCloud.getMsg('medweb.view.waitingroom.endchat.label'),
            placecall: MedwebCloud.getMsg('medweb.view.waitingroom.placecall.label'),
            startvideo: MedwebCloud.getMsg('medweb.view.waitingroom.endvideo.label'),
            endvideo: MedwebCloud.getMsg('medweb.view.waitingroom.endvideo.label'),
            showscreen: MedwebCloud.getMsg('medweb.view.waitingroom.showscreen.label'),
            transferfile: MedwebCloud.getMsg('medweb.view.waitingroom.transferfile.label'),
            mutevideo: MedwebCloud.getMsg('medweb.view.waitingroom.mutevideo.label'),
            muteaudio: MedwebCloud.getMsg('medweb.view.waitingroom.muteaudio.label'),
            send: MedwebCloud.getMsg('medweb.view.waitingroom.send.label'),
            sharescreen: MedwebCloud.getMsg('medweb.view.waitingroom.sharescreen.label')
        };

        var transferSession = function (sessionId, chatId, email, displayName, messages, successCallback, failureCallback) {
           // debugger;
            var invitation = Ext.create('MedwebCloud.model.SessionTransfer', {
                SessionId: sessionId,
                ChatId: chatId,
                Email: email,
                DisplayName: displayName,
                Messages: messages
            });
            invitation.save({
                failure: function (args) {
                    if (!!failureCallback) {
                        failureCallback.call(me, args, sessionId, chatId, email, displayName);
                    }
                },
                success: function (args) {
                    if (!!successCallback) {
                        successCallback.call(me, args, sessionId, chatId, email, displayName);
                    }
                }
            });
        };
        var showTransferDialog = function (message, sessionId, chatId, messages, successCallback, failureCallback) {
            var contacts = Ext.create("MedwebCloud.view.WaitingRoom.InvitationWindow", {
                title:message,
                closeAction: 'close',
                width: 400,
                height: 400,
                minWidth: 300,
                minHeight: 300,
                resizable: true,
                modal: true,
                listeners: {
                    invite: function (email, display) {
                        transferSession(sessionId, chatId, email, display, messages, function () {
                            if (!!successCallback) {
                                successCallback.apply(this, arguments);
                            }
                            contacts.close();
                        }, failureCallback);
                    }
                }
            })

            contacts.show();
        }

        Ext.apply(me, {
            layout: 'border',
            items: [{
                region: 'west',
                title: MedwebCloud.getMsg('medweb.viewport.button.evisit.label'),
                collapsible: true,
                split: true,
                width: 400,
                layout: {
                    type: 'accordion',
                    multi: true
                },
                items: [{
                    title: labels.waiting,
                    flex: 2,
                    width: '100%',
                    xtype: 'MedwebCloud.wr.chatrequestsgrid',
                    collapsed: MedwebCloud.userProfile.isDoctor(),
                    client: this.client,
                    viewConfig: {
                        plugins: {
                            ptype: 'gridviewdragdrop',
                            dragGroup: 'chats'
                        }
                    },
                    border: false,
                    listeners: {
                        startChat: Ext.Function.bind(me.startChatHandler, me)
                    }
                }, {
                    title: labels.active,
                    flex: 4,
                    width: '100%',
                    collapsed: MedwebCloud.userProfile.isDoctor(),
                    xtype: 'MedwebCloud.wr.activechatsgrid',
                    client: this.client,
                    border: false,
                    viewConfig: {
                        plugins: {
                            ptype: 'gridviewdragdrop',
                            dragGroup: 'chats'
                        }
                    },
                    listeners: {
                        startChat: Ext.Function.bind(me.startChatHandler, me)
                    }
                }, {
                    title: labels.doctors,
                    flex: 4,
                    width: '100%',
                    client: this.client,
                    border: false,
                    xtype: 'MedwebCloud.wr.doctorsgrid',
                    collapsed: MedwebCloud.userProfile.isDoctor(),
                    viewConfig: {
                        plugins: {
                            ptype: 'gridviewdragdrop',
                            enableDrag: false,
                            dropGroup: 'chats'
                        },
                        listeners: {
                            beforedrop: function (node, data, overModel, dropPosition, dropFunction, eOpts) {
                                var record = data.records[0];
                                //console.log(data.records[0].get('Name'), overModel.get('DisplayName'));
                                var userChannel = '/' + MedwebCloud.userProfile.CompanyId + '/user/' + overModel.get('Id');
                                record.store.remove(record);

                                me.client.publish({
                                    channel: userChannel,
                                    data: {
                                        NotificationType: 'waitingroomchatrequestassigned',
                                        From: MedwebCloud.userProfile,
                                        ChatRequest: Ext.apply(record.data, {
                                            Chat: record.getChat().data
                                        })
                                    },
                                    onSuccess: function () {
                                        var body = MedwebCloud.getMsg('medweb.view.waitingroom.action.assigned.success.message',  overModel.get('DisplayName'));
                                        Ext.Msg.toast({ body: body});
                                    },
                                    onFailure: function (e) {
                                        console.log(e);
                                    }
                                });
                                return false;
                            }
                        }
                    }
                },
                {
                    title: labels.sessions,
                    flex: 4,
                    width: '100%',
                    client: this.client,
                    border: false,
                    xtype: 'MedwebCloud.wr.sessionsgrid',
                    collapsed: false,
                    viewConfig: {
                        plugins: {
                            ptype: 'gridviewdragdrop',
                            enableDrag: false,
                            dropGroup: 'chats'
                        },
                        listeners: {
                            beforedrop: function (node, data, overModel, dropPosition, dropFunction, eOpts) {
                               // debugger;
                                var chatRequest = data.records[0];
                                var chatId = chatRequest.get("Id");
                                var messages = chatRequest.getTransfer();
                                var chatUser = chatRequest.raw.User;
                                var sessionId = overModel.get("Id");
                                var sessionName = overModel.get("Name");
                                var required = '<span style="color:red;font-weight:bold" data-qtip="' +MedwebCloud.getMsg('medweb.common.required.label')+ '">*</span>';
                                var win;

                                var failureCallback = function (record, sessionId, chatId, chatUserEmail, chatUserDisplayName) {
                                    console.log(record);
                                    Ext.Msg.alert(
                                        MedwebCloud.getMsg('medweb.view.sessionsgrid.action.transfer.failure.title',  chatUserDisplayName),
                                        MedwebCloud.getMsg('medweb.view.sessionsgrid.action.transfer.failure.message',  chatUserDisplayName)
                                    );
                                };
                                var successCallback = function (args, sessionId, chatId, email, displayName) {
                                    Ext.Msg.show({
                                        title: MedwebCloud.getMsg('medweb.view.sessionsgrid.action.transfer.success.title'),
                                        msg: MedwebCloud.getMsg('medweb.view.sessionsgrid.action.transfer.success.message'),
                                        buttons: Ext.Msg.OKCANCEL,
                                        buttonText: { ok: MedwebCloud.getMsg('medweb.common.button.positive.label'), cancel: MedwebCloud.getMsg('medweb.common.button.negative.label') },
                                        fn: function (btn) {
                                            if (btn === 'ok') {
                                                MedwebCloud.app.Viewport.goToSection({
                                                    name: 'collage',
                                                    subsection: {
                                                        name: 'session',
                                                        ref: sessionId.toString(10)
                                                    }
                                                })
                                            }
                                        },
                                        icon: Ext.window.MessageBox.INFO
                                    });
                                };
                                var showTransfer = function (sessionId, chatId){
                                    showTransferDialog(MedwebCloud.getMsg('medweb.view.sessionsgrid.action.transfer.title'), sessionId, chatId, messages, successCallback, failureCallback);
                                }
                                if (!!chatUser) {
                                    transferSession(sessionId, chatId, chatUser.Username, chatUser.DisplayName, messages,  successCallback, function (f, sessionId, chatId, email, displayName) {
                                        showTransfer(sessionId, chatId);
                                    });
                                } else {
                                    showTransfer(sessionId, chatId);
                                }
                                return false;
                            }
                        }
                    }
                }, {
                    title: labels.assignedtome,
                    flex: 4,
                    width: '100%',
                    xtype: 'MedwebCloud.wr.assignedchatsgrid',
                    collapsed: !MedwebCloud.userProfile.isDoctor(),
                    client: this.client,
                    border: false,
                    listeners: {
                        startChat: Ext.Function.bind(me.startChatHandler, me)
                    }
                }]
            }, {
                xtype: 'tabpanel',
                region: 'center',
                plain: true,
                cls: 'mainTabPanel',
                items: []
            }]
        });

        me.callParent(arguments);
    },
    startChatHandler: function (args) {
        var me = this;
        var tabPanel = me.down('tabpanel');

        var chatTab = me.findTab(args.chat.get('Id'));
        if (chatTab == null){
            chatTab = tabPanel.add({
                xtype: 'MedwebCloud.wr.chatpanel',
                client: me.client,
                title: args.chatRequest.get('DisplayName'),
                chat: args.chat,
                chatRequest: args.chatRequest,
                closable: true,
                listeners: {
                    endChat: function () {
                        //args.chatRequest.store.remove(args.chatRequest);
                    }
                }
            });
        }
        tabPanel.setActiveTab(chatTab);

        me.fireEvent('chatstarted');
    },
    findTab: function (chatId) {
        var me = this;
        var tabPanel = me.down('tabpanel');
        var subtabs = tabPanel.items.items;
        for (var i = 0; i < subtabs.length; i++) {
            if (subtabs[i].chat.get('Id') == chatId) {
                return subtabs[i];
            }
        }

        return null;
    }
});