﻿ function doTranslation(applicationPairs, companyPairs, callback) {
    var mwc = window.MedwebCloud;
    mwc.getMsg = function (key) {
        var template = applicationPairs[key];
        var subs = Array.prototype.slice.call(arguments, 1);
        return formatString(template, subs);
    };
    //mwc.getCompanyMsg = function (key) {
    //    var template = companyPairs[key];
    //    var subs = Array.prototype.slice.call(arguments, 1);
    //    return formatString(template, subs);
    //};
    var appRegex = /{i:([\w\.]+?)}/g;
    var compRegex = /{c:([\w\.]+?)}/g;

    function applicationSub(string) {
        if (string != null) {
            string = string.toString(10);
            return string.replace(appRegex, function ($0, $1) {
                return applicationPairs.hasOwnProperty($1) ? applicationPairs[$1] : '{i:' + $1 + '.undefined}';
            });
        } else {
            return string;
        }
    }

    function companySub(string) {
        if (string != null) {
            string = string.toString(10);
            return string.replace(compRegex, function ($0, $1) {
                return companyPairs.hasOwnProperty($1) ? companyPairs[$1] : '{c:' + $1 + '.undefined}';
            });
        } else {
            return string;
        }
    }
    //Preapply company substitutions
    var key;
    var hasSubs = [];
    for (key in companyPairs) {
        var value = companyPairs[key];
        value = applicationSub(value)
        value = companySub(value)
        if (compRegex.test(value)) {
            hasSubs.push(key);
        }
        companyPairs[key] = value;
    }

    var sanity = 8;

    while (hasSubs.length > 0 && sanity--) { //A company property may refer to some other company property. we do it a few times so that we can 
        var newsubs = []
        for (i = hasSubs.length; i > 0; i--) {
            key = hasSubs[i];
            var value = companyPairs[key];
            value = companySub(value)
            if (compRegex.test(value)) {
                newsubs.push(key);
            }
            companyPairs[key] = value;
        }
        hasSubs = newsubs;
    }

    $(document).ready(function () {
        // first, translate all the "real" dom entities without destroying them all
        var re = /{i:([\w\.]+?)}/g;
        $(':contains({i:)').filter(function () {
            return $(this).children().length === 0;
        }).html(function (idx, oldHtml) {
            return applicationSub(oldHtml);
        });
        $(':contains({c:)').filter(function () {
            return $(this).children().length === 0;
        }).html(function (idx, oldHtml) {
            return companySub(oldHtml);
        });

        // then translate all the embedded content in text/html tags
        $(document.body).html(function (idx, oldHtml) {
            return applicationSub(companySub(oldHtml));
        }).show();

        if ( !! callback && !! callback.call) {
            callback();
        }
    });
} //end doTranslation


function DoLocalization() {
    $.get('/scripts/lang/Application_' + MedwebCloud.UIConfig.UserCulture.Name + '.txt', function (bundle) {
        // translation stuff
        var languageElements = bundle.split('\n');
        var languagePairs = {};
        for (var i = 0; i < languageElements.length; i++) {
            var pair = languageElements[i].split('=');
            if (pair.length > 1) {
                languagePairs[pair[0].trim()] = pair[1].trim();
            }
        }
        delete languageElements;
        doTranslation(languagePairs, {});
    }); 
}